VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cExportHtml"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements iExport

Private mFileName As String
Private mRs As RC6.cRecordset
Private mSlots As Integer
Private mSB As cStringBuilder
Private mColFeiertag As String, mColFerien As String, mColUrlaub As String
Private mLegende As RC6.cRecordset
Const mFilter As String = "HTML (*.html)|*.html"
Const mExtension As String = ".html"


Private Function iExport_GetData(Settings As RC6.cHashD) As Byte()
Dim tmpl As String
Dim i As Integer, jahr As Integer
    'id_kalender,tag,monat,wtag,we,id_ferientag,feiertag,burlaub,slot,anteil,kuerzel,name,farbe
    jahr = CInt(Settings("jahr"))
    mSlots = CInt(Settings("slots")) + 2
    mColFeiertag = Settings("cFeiertag")
    mColFerien = Settings("cFerien")
    mColUrlaub = Settings("cUrlaub")
    Set mSB = New_c.StringBuilder
    tmpl = HtmlHelper.Crypt.UTF8ToVBString(HtmlHelper.AppRes.GetContent("urlaubsplaner.html"))
    i = InStr(tmpl, "<!--skin-->")
    With mSB
        If i > 0 Then .Add Left$(tmpl, i - 1)
        .AddNL "</head><body>"
        .AddNL "<h1>Urlaubsplaner " & jahr & "</h1>"
        iExport_GetData = .ToUTF8
        If Not mRs Is Nothing Then PrintKalender 1
        .Add "</body></html>"
        iExport_GetData = .ToUTF8
    End With
    
End Function


Private Sub PrintKalender(ByVal monat As Integer)
Dim tag As Integer, slot As Integer
Dim style As String
Dim isFrei As Boolean
    With mSB
        If monat > 1 Then .AddNL "</tbody></table>"
        .AddNL "<table style='display:inline-block;vertical-align:top;margin-left:10px;margin-top:10px;'><thead>"
        .Add "<colgroup>"
        For slot = slot To mSlots - 1
            .Add "<col style='width:3em'>"
        Next
        slot = 1
        .AddNL "</colgroup>"
        .Add "<thead><tr><th colspan=" & mSlots & ">" & MonthName(monat) & "</th></tr>"
        .AddNL "</thead><tbody>"

        Do
            If tag <> mRs!tag Then
                If tag > 0 Then
                    For slot = slot To mSlots
                        .Add "<td></td>"
                    Next
                    .AddNL "</tr>"
                End If
                tag = mRs!tag
                slot = 3
                If monat <> mRs!monat Then
                    PrintKalender mRs!monat
                    Exit Do
                End If
                .Add "<tr>"
                If Not IsEmpty(mRs!feiertag) Then    'Feiertag
                    style = " style='background-color:" & mColFeiertag & ";color:" & HtmlHelper.CompColor(mColFeiertag) & "'"
                    .Add "<td class='r'" & style & ">" & mRs!tag & "</td>"
                    .Add "<td" & style & ">" & mRs!wtag & "</td>"
                    .Add "<td" & style & " class='fday' colspan=" & (mSlots - 2) & ">" & mRs!feiertag & "</td>"
                    isFrei = True
                    slot = mSlots + 2
                ElseIf Not IsEmpty(mRs!burlaub) Then 'Betriebsurlaub
                     style = " style='background-color:" & mColUrlaub & ";color:" & HtmlHelper.CompColor(mColUrlaub) & "'"
                    .Add "<td class='r'" & style & ">" & mRs!tag & "</td>"
                    .Add "<td" & style & ">" & mRs!wtag & "</td>"
                    .Add "<td" & style & " class='fday' colspan=" & (mSlots - 2) & ">" & mRs!burlaub & "</td>"
                    isFrei = True
                    slot = mSlots + 2
                ElseIf mRs!we Then  'Wochenende
                    style = " style='background-color:#CCC'" 'Wochenende
                    isFrei = True
                    .Add "<td class='r'" & style & ">" & mRs!tag & "</td>"
                    .Add "<td" & style & ">" & mRs!wtag & "</td>"
                    .Add "<td" & style & " colspan=" & (mSlots - 2) & "></td>"
                    isFrei = True
                    slot = mSlots + 2
                ElseIf Not IsEmpty(mRs!id_ferien) Then
                    style = " style='background-color:" & mColFerien & ";color:" & HtmlHelper.CompColor(mColFerien) & "'"
                    .Add "<td class='r'" & style & ">" & mRs!tag & "</td>"
                    .Add "<td" & style & ">" & mRs!wtag & "</td>"
                Else
                    .Add "<td class='r'>" & mRs!tag & "</td>"
                    .Add "<td>" & mRs!wtag & "</td>"
                End If
            End If
            If Not isFrei Then
                If Not IsEmpty(mRs!kuerzel) Then
                    For slot = slot To mRs!slot + 1
                        .Add "<td></td>"
                    Next
                    .Add "<td style='background-color:" & mRs!farbe & ";color:" & HtmlHelper.CompColor(mRs!farbe) & "' title='" & mRs!name & "'>" & mRs!kuerzel & "</td>"
                    slot = mRs!slot + 3
                End If
            End If
            isFrei = False
            mRs.MoveNext
        Loop Until mRs.EOF
        If monat = 1 Then .AddNL "</tbody></table>"
    End With
End Sub


Private Property Let iExport_FileName(RHS As String)
    mFileName = RHS
    If Right$(LCase$(mFileName), Len(mExtension)) <> mExtension Then mFileName = mFileName & mExtension
End Property

Private Property Get iExport_FileExtension() As String
    iExport_FileExtension = mExtension
End Property

Private Property Get iExport_FileName() As String
    iExport_FileName = mFileName
End Property

Private Property Set iExport_Legende(RHS As RC6.cRecordset)
    Set mLegende = RHS
End Property

Private Property Get iExport_Legende() As RC6.cRecordset
    Set iExport_Legende = mLegende
End Property

Private Property Set iExport_Recordset(RHS As RC6.cRecordset)
    Set mRs = RHS
End Property

Private Property Get iExport_Recordset() As RC6.cRecordset
    Set iExport_Recordset = mRs
End Property


Private Property Get iExport_Filter() As String
    iExport_Filter = mFilter
End Property




