VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cExportJpg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements iExport

Private mFileName As String
Private mRs As RC6.cRecordset
Private mCC As RC6.cCairoContext
Private mJPGSrf As RC6.cCairoSurface
Const mFilter As String = "JPG (*.jpg)|*.jpg|PNG (*.png)|*.png"

Private mExtension As String
Private mSlots As Integer
Private mColFeiertag As String, mColFerien As String, mColUrlaub As String
Private mColWidth As Double
Private mRowHeight As Double
Private mFontHeight As Integer
Private mLegende As RC6.cRecordset
Private mLegendeCols() As Double

Private Sub Class_Initialize()
    mExtension = ".jpg"
End Sub

Private Function iExport_GetData(Settings As RC6.cHashD) As Byte()
Dim i As Integer, jahr As Integer


    jahr = CInt(Settings("jahr"))
    mSlots = CInt(Settings("slots")) + 2
    mColFeiertag = Settings("cFeiertag")
    mColFerien = Settings("cFerien")
    mColUrlaub = Settings("cUrlaub")
    mFontHeight = 9
    mColWidth = 24
    mRowHeight = 20
    
    'Legende vorbereiten
    i = mLegende.RecordCount
    If i < 4 Then i = 4
    If i > 7 Then i = 7
    ReDim mLegendeCols(i)
    mLegendeCols(0) = (mSlots * mColWidth * 12) / (i + 1)
    For i = UBound(mLegendeCols) To 0 Step -1
        mLegendeCols(i) = i * mLegendeCols(0)
    Next

    Set mJPGSrf = Cairo.CreateSurface(mSlots * mColWidth * 12 + 1, mRowHeight * 38, RC6.ImageSurface)
    Set mCC = mJPGSrf.CreateContext
    mCC.SetSourceColor vbWhite
    mCC.Paint

    mCC.SelectFont "Times New Roman", mFontHeight + 4, vbBlack, True, True
    mCC.TextOut 0, 0, "Urlaubsplaner " & jahr
    
    If Not mRs Is Nothing Then
        PrintKalender 1
    End If
    PrintLegende
    Set mCC = Nothing

    If mExtension = ".png" Then
        mJPGSrf.WriteContentToPngByteArray iExport_GetData
    Else
        mJPGSrf.WriteContentToJpgByteArray iExport_GetData, 95
    End If


End Function



Private Sub PrintKalender(monat As Integer)
Dim tag As Integer, slot As Integer
Dim fillColor As OLE_COLOR
Dim isFrei As Boolean
Dim xMonat As Double, yTag As Double

    xMonat = mColWidth * (monat - 1) * mSlots
    mCC.Save
    mCC.SelectFont "Times New Roman", mFontHeight + 3, vbWhite, True, False
    mCC.DrawTextCell xMonat, mRowHeight + 2, mColWidth * mSlots, mRowHeight + 2, MonthName(monat), False, vbLeftJustify, 1, vbBlack, 0
    Do
        If tag <> mRs!tag Then
            If tag > 0 Then
                For slot = slot To mSlots - 2
                    mCC.DrawTextCell xMonat + ((slot + 1) * mColWidth), yTag, mColWidth, mRowHeight, "", False, vbLeftJustify, 1, vbWhite, 0
                Next
            End If
            tag = mRs!tag
            yTag = ((tag + 1) * mRowHeight) + 4
            slot = 1
            If monat <> mRs!monat Then
                monat = mRs!monat
                PrintKalender monat
                Exit Do
            End If
            If Not IsEmpty(mRs!feiertag) Then    'Feiertag
                fillColor = CellColor(mColFeiertag)
                mCC.DrawTextCell xMonat, yTag, mColWidth, mRowHeight, mRs!tag, False, vbRightJustify, 1, fillColor, 0
                mCC.DrawTextCell xMonat + mColWidth, yTag, mColWidth * (mSlots - 1), mRowHeight, mRs!feiertag, False, vbLeftJustify, 1, fillColor, 0
                isFrei = True
                slot = mSlots
            ElseIf Not IsEmpty(mRs!burlaub) Then 'Betriebsurlaub
                fillColor = CellColor(mColUrlaub)
                mCC.DrawTextCell xMonat, yTag, mColWidth, mRowHeight, mRs!tag, False, vbRightJustify, 1, fillColor, 0
                mCC.DrawTextCell xMonat + mColWidth, yTag, mColWidth * (mSlots - 1), mRowHeight, mRs!burlaub, False, vbLeftJustify, 1, fillColor, 0
                isFrei = True
                slot = mSlots
            ElseIf mRs!we Then  'Wochenende
                fillColor = CellColor("#CCC")
                mCC.DrawTextCell xMonat, yTag, mColWidth, mRowHeight, mRs!tag, False, vbRightJustify, 1, fillColor, 0
                mCC.DrawTextCell xMonat + mColWidth, yTag, mColWidth * (mSlots - 1), mRowHeight, mRs!wtag, False, vbLeftJustify, 1, fillColor, 0
                isFrei = True
                slot = mSlots
            ElseIf Not IsEmpty(mRs!id_ferien) Then
                fillColor = CellColor(mColFerien)
                mCC.DrawTextCell xMonat, yTag, mColWidth, mRowHeight, mRs!tag, False, vbRightJustify, 1, fillColor, 0
                mCC.DrawTextCell xMonat + mColWidth, yTag, mColWidth, mRowHeight, mRs!wtag, False, vbLeftJustify, 1, fillColor, 0
            Else
                fillColor = CellColor("#FFF")
                mCC.DrawTextCell xMonat, yTag, mColWidth, mRowHeight, mRs!tag, False, vbRightJustify, 1, fillColor, 0
                mCC.DrawTextCell xMonat + mColWidth, yTag, mColWidth, mRowHeight, mRs!wtag, False, vbLeftJustify, 1, fillColor, 0
            End If
        End If
        If Not isFrei Then
            If IsEmpty(mRs!kuerzel) Then
                mCC.DrawTextCell xMonat + ((slot + 1) * mColWidth), yTag, mColWidth, mRowHeight, "", False, vbLeftJustify, 1, vbWhite, 0
            Else
                For slot = slot To mRs!slot - 1
                    mCC.DrawTextCell xMonat + ((slot + 1) * mColWidth), yTag, mColWidth, mRowHeight, "", False, vbLeftJustify, 1, vbWhite, 0
                Next
                fillColor = CellColor(mRs!farbe)
                mCC.DrawTextCell xMonat + ((mRs!slot + 1) * mColWidth), yTag, mColWidth, mRowHeight, mRs!kuerzel, False, vbCenter, 0, fillColor, 0, , 0.3
                slot = mRs!slot + 1
            End If
        End If
        isFrei = False
        mRs.MoveNext
    Loop Until mRs.EOF
    mCC.Restore
End Sub

Private Sub PrintLegende()
Dim fillColor As OLE_COLOR
Dim col As Integer, row As Single, rows As Integer, cols As Integer
    cols = UBound(mLegendeCols) + 1
    mCC.Save
    rows = (mLegende.RecordCount - 1) \ cols + 1
    Do Until mLegende.EOF
        If col >= cols And row < rows - 1 Then
            col = 0 'Zeilenwechsel
            row = row + 1.2
        End If
        fillColor = CellColor(mLegende!farbe)
        mCC.DrawTextCell mLegendeCols(col), mRowHeight * (33.7 + row), mColWidth, mRowHeight, mLegende!kuerzel, False, vbCenter, 0, fillColor, 0, , 0.3
        fillColor = CellColor("#FFF")
        mCC.DrawTextCell mLegendeCols(col) + mColWidth + 3, mRowHeight * (33.7 + row), mLegendeCols(1), mRowHeight, mLegende!name, False, vbLeftJustify, 0, fillColor, 0, , 0
        mLegende.MoveNext
        col = col + 1
    Loop
    
    mCC.Restore
End Sub

Private Function CellColor(color As String) As OLE_COLOR
Dim CompColor As OLE_COLOR
Dim r As String, g As String, b As String
Dim rt As Integer, gn As Integer, bl As Integer
Const dark As Integer = 450
    If Len(color) = 4 Then
        r = Mid$(color, 2, 1): rt = CInt("&H" & r & r)
        g = Mid$(color, 3, 1): gn = CInt("&H" & g & g)
        b = Mid$(color, 4, 1): bl = CInt("&H" & b & b)
    ElseIf Len(color) = 7 Then
        r = Mid$(color, 2, 2): rt = CInt("&H" & r)
        g = Mid$(color, 4, 2): gn = CInt("&H" & g)
        b = Mid$(color, 6, 2): bl = CInt("&H" & b)
    End If
    If rt + gn + bl > dark Then CompColor = vbBlack Else CompColor = vbWhite
    CellColor = RGB(rt, gn, bl)
    mCC.SelectFont "Arial", mFontHeight, CompColor, False, False
End Function

Private Property Let iExport_FileName(RHS As String)
    mFileName = RHS
    mExtension = "." & LCase$(New_c.fso.GetFileExtension(mFileName))
    If mExtension <> ".jpg" And mExtension <> ".png" Then mExtension = ".jpg"
    If Right$(LCase$(mFileName), Len(mExtension)) <> mExtension Then mFileName = mFileName & mExtension
End Property

Private Property Get iExport_FileExtension() As String
    iExport_FileExtension = mExtension
End Property

Private Property Get iExport_FileName() As String
    iExport_FileName = mFileName
End Property

Private Property Set iExport_Legende(RHS As RC6.cRecordset)
    Set mLegende = RHS
End Property

Private Property Get iExport_Legende() As RC6.cRecordset
    Set iExport_Legende = mLegende
End Property

Private Property Set iExport_Recordset(RHS As RC6.cRecordset)
    Set mRs = RHS
End Property

Private Property Get iExport_Recordset() As RC6.cRecordset
    Set iExport_Recordset = mRs
End Property

Private Property Get iExport_Filter() As String
    iExport_Filter = mFilter
End Property







