VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cExportPdf"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements iExport

Private mFileName As String
Private mRs As RC6.cRecordset
Private mCC As RC6.cCairoContext
Private mPDFSrf As RC6.cCairoSurface
Const mFilter As String = "PDF (*.pdf)|*.pdf"
Const mExtension As String = ".pdf"

Private mSlots As Integer
Private mColFeiertag As String, mColFerien As String, mColUrlaub As String
Private mColWidth As Double
Private mRowHeight As Double
Private mFontHeight As Integer
Private mPages As Integer
Private mPage As Integer
Private mPageWidthPoints As Double, mPageHeightPoints As Double
Private mLegende As RC6.cRecordset
Private mLegendeCols() As Double

Private Sub Class_Initialize()
    mPage = 1
End Sub

Private Function iExport_GetData(Settings As RC6.cHashD) As Byte()
Dim leftMarginPoints As Double
Dim rightMarginPoints As Double
Dim pageScaleWidth As Double
Dim pageScaleHeight As Double
Const topMarginPoints As Double = 10
Const bottomMarginPoints As Double = 10
Dim i As Integer, jahr As Integer


    jahr = CInt(Settings("jahr"))
    mSlots = CInt(Settings("slots")) + 2
    mColFeiertag = Settings("cFeiertag")
    mColFerien = Settings("cFerien")
    mColUrlaub = Settings("cUrlaub")
    Select Case Settings("format")
        Case 1  'A4-Quer
            mPageWidthPoints = 842:  mPageHeightPoints = 595: mPages = 1
            rightMarginPoints = 10: leftMarginPoints = 10
            Select Case mSlots
                Case 4, 5: mFontHeight = 5
                Case 6:    mFontHeight = 4
                Case Else: mFontHeight = 3
            End Select
        Case 2  '2x A3-Hoch
            mPageWidthPoints = 842:  mPageHeightPoints = 1191: mPages = 2
            rightMarginPoints = 20: leftMarginPoints = 20
            Select Case mSlots
                Case 4, 5: mFontHeight = 9
                Case 6:    mFontHeight = 8
                Case Else: mFontHeight = 7
            End Select
        Case 3  '2x A4-Quer
            mPageWidthPoints = 842:  mPageHeightPoints = 595: mPages = 2
            rightMarginPoints = 20: leftMarginPoints = 20
            Select Case mSlots
                Case 4, 5: mFontHeight = 9
                Case 6:    mFontHeight = 8
                Case 7:    mFontHeight = 7
                Case Else: mFontHeight = 6
            End Select
        Case Else 'A3-Quer
            mPageWidthPoints = 1191: mPageHeightPoints = 842: mPages = 1
            rightMarginPoints = 10: leftMarginPoints = 10
            Select Case mSlots
                Case 4, 5: mFontHeight = 7
                Case 6:    mFontHeight = 6
                Case Else: mFontHeight = 5
            End Select
    End Select
    'Legende vorbereiten
    i = Round((mLegende.RecordCount / (2 * mPages)) + 0.5)
    If i < 4 Then i = 4
    ReDim mLegendeCols(i)
    mLegendeCols(0) = (mPageWidthPoints - leftMarginPoints - rightMarginPoints) / (i + 1)
    For i = UBound(mLegendeCols) To 0 Step -1
        mLegendeCols(i) = i * mLegendeCols(0)
    Next

    Set mPDFSrf = Cairo.CreateSurface(mPageWidthPoints, mPageHeightPoints, RC6.PDFSurface)
    Set mCC = mPDFSrf.CreateContext
    mCC.SetSourceColor vbWhite
    mCC.Paint
    mPageWidthPoints = mCC.Surface.Width: mPageHeightPoints = mCC.Surface.Height
    mCC.DeviceToUserDistance mPageWidthPoints, mPageHeightPoints
    mCC.TranslateDrawings leftMarginPoints, topMarginPoints
    pageScaleWidth = mPageWidthPoints - leftMarginPoints - rightMarginPoints
    pageScaleHeight = mPageHeightPoints - topMarginPoints - bottomMarginPoints
    mColWidth = (pageScaleWidth * mPages) / (12 * mSlots)
    mRowHeight = pageScaleHeight / 36

    mCC.SelectFont "Times New Roman", mFontHeight + 4, vbBlack, True, True
    mCC.TextOut 0, 0, "Urlaubsplaner " & jahr
    
    If Not mRs Is Nothing Then
        PrintKalender 1
    End If
    PrintLegende
    mPDFSrf.EmitPDFPage
    Set mCC = Nothing

    mPDFSrf.WriteContentToPDFByteArray iExport_GetData


End Function



Private Sub PrintKalender(monat As Integer)
Dim tag As Integer, slot As Integer
Dim fillColor As OLE_COLOR
Dim isFrei As Boolean
Dim xMonat As Double, yTag As Double
    If mPages = 2 And monat > 6 Then
        xMonat = mColWidth * (monat - 7) * mSlots
    Else
        xMonat = mColWidth * (monat - 1) * mSlots
    End If
    mCC.Save
    mCC.SelectFont "Times New Roman", mFontHeight + 3, vbWhite, True, False
    mCC.DrawTextCell xMonat, mRowHeight + (2 * mPages), mColWidth * mSlots, mRowHeight + (2 * mPages), MonthName(monat), False, vbLeftJustify, 1, vbBlack, 0
    Do
        If tag <> mRs!tag Then
            If tag > 0 Then
                For slot = slot To mSlots - 2
                    mCC.DrawTextCell xMonat + ((slot + 1) * mColWidth), yTag, mColWidth, mRowHeight, "", False, vbLeftJustify, 1, vbWhite, 0
                Next
            End If
            tag = mRs!tag
            yTag = ((tag + 1) * mRowHeight) + (4 * mPages)
            slot = 1
            If monat <> mRs!monat Then
                monat = mRs!monat
                If monat = 7 And mPages = 2 Then
                    PrintLegende
                    mPDFSrf.EmitPDFPage False, mPageWidthPoints, mPageHeightPoints
                End If
                PrintKalender monat
                Exit Do
            End If
            If Not IsEmpty(mRs!feiertag) Then    'Feiertag
                fillColor = CellColor(mColFeiertag)
                mCC.DrawTextCell xMonat, yTag, mColWidth, mRowHeight, mRs!tag, False, vbRightJustify, 1, fillColor, 0
                mCC.DrawTextCell xMonat + mColWidth, yTag, mColWidth * (mSlots - 1), mRowHeight, mRs!feiertag, False, vbLeftJustify, 1, fillColor, 0
                isFrei = True
                slot = mSlots
            ElseIf Not IsEmpty(mRs!burlaub) Then 'Betriebsurlaub
                fillColor = CellColor(mColUrlaub)
                mCC.DrawTextCell xMonat, yTag, mColWidth, mRowHeight, mRs!tag, False, vbRightJustify, 1, fillColor, 0
                mCC.DrawTextCell xMonat + mColWidth, yTag, mColWidth * (mSlots - 1), mRowHeight, mRs!burlaub, False, vbLeftJustify, 1, fillColor, 0
                isFrei = True
                slot = mSlots
            ElseIf mRs!we Then  'Wochenende
                fillColor = CellColor("#CCC")
                mCC.DrawTextCell xMonat, yTag, mColWidth, mRowHeight, mRs!tag, False, vbRightJustify, 1, fillColor, 0
                mCC.DrawTextCell xMonat + mColWidth, yTag, mColWidth * (mSlots - 1), mRowHeight, mRs!wtag, False, vbLeftJustify, 1, fillColor, 0
                isFrei = True
                slot = mSlots
            ElseIf Not IsEmpty(mRs!id_ferien) Then
                fillColor = CellColor(mColFerien)
                mCC.DrawTextCell xMonat, yTag, mColWidth, mRowHeight, mRs!tag, False, vbRightJustify, 1, fillColor, 0
                mCC.DrawTextCell xMonat + mColWidth, yTag, mColWidth, mRowHeight, mRs!wtag, False, vbLeftJustify, 1, fillColor, 0
            Else
                fillColor = CellColor("#FFF")
                mCC.DrawTextCell xMonat, yTag, mColWidth, mRowHeight, mRs!tag, False, vbRightJustify, 1, fillColor, 0
                mCC.DrawTextCell xMonat + mColWidth, yTag, mColWidth, mRowHeight, mRs!wtag, False, vbLeftJustify, 1, fillColor, 0
            End If
        End If
        If Not isFrei Then
            If IsEmpty(mRs!kuerzel) Then
                mCC.DrawTextCell xMonat + ((slot + 1) * mColWidth), yTag, mColWidth, mRowHeight, "", False, vbLeftJustify, 1, vbWhite, 0
            Else
                For slot = slot To mRs!slot - 1
                    mCC.DrawTextCell xMonat + ((slot + 1) * mColWidth), yTag, mColWidth, mRowHeight, "", False, vbLeftJustify, 1, vbWhite, 0
                Next
                fillColor = CellColor(mRs!farbe)
                mCC.DrawTextCell xMonat + ((mRs!slot + 1) * mColWidth), yTag, mColWidth, mRowHeight, mRs!kuerzel, False, vbCenter, 0, fillColor, 0, , 0.3
                slot = mRs!slot + 1
            End If
        End If
        isFrei = False
        mRs.MoveNext
    Loop Until mRs.EOF
    mCC.Restore
End Sub

Private Sub PrintLegende()
Dim fillColor As OLE_COLOR
Dim col As Integer, row As Integer, rows As Integer, cols As Integer
    cols = UBound(mLegendeCols) + 1
    mCC.Save
    rows = (mLegende.RecordCount - 1) \ (mPages * cols) + 1
    Do Until mLegende.EOF
        Select Case True
            Case col >= cols And row = rows - 1 And mPage <= mPages
                Exit Do 'Seitenwechsel
            Case col >= cols And row < rows - 1
                col = 0 'Zeilenwechsel
                row = row + 1
        End Select
        
        fillColor = CellColor(mLegende!farbe)
        mCC.DrawTextCell mLegendeCols(col), mRowHeight * (33.7 + row), mColWidth, mRowHeight, mLegende!kuerzel, False, vbCenter, 0, fillColor, 0, , 0.3
        fillColor = CellColor("#FFF")
        mCC.DrawTextCell mLegendeCols(col) + mColWidth + 3, mRowHeight * (33.7 + row), mPageWidthPoints, mRowHeight, mLegende!name, False, vbLeftJustify, 0, fillColor, 0, , 0
        mLegende.MoveNext
        col = col + 1
    Loop
    
    mCC.Restore
End Sub

Private Function CellColor(color As String) As OLE_COLOR
Dim CompColor As OLE_COLOR
Dim r As String, g As String, b As String
Dim rt As Integer, gn As Integer, bl As Integer
Const dark As Integer = 450
    If Len(color) = 4 Then
        r = Mid$(color, 2, 1): rt = CInt("&H" & r & r)
        g = Mid$(color, 3, 1): gn = CInt("&H" & g & g)
        b = Mid$(color, 4, 1): bl = CInt("&H" & b & b)
    ElseIf Len(color) = 7 Then
        r = Mid$(color, 2, 2): rt = CInt("&H" & r)
        g = Mid$(color, 4, 2): gn = CInt("&H" & g)
        b = Mid$(color, 6, 2): bl = CInt("&H" & b)
    End If
    If rt + gn + bl > dark Then CompColor = vbBlack Else CompColor = vbWhite
    CellColor = RGB(rt, gn, bl)
    mCC.SelectFont "Arial", mFontHeight, CompColor, False, False
End Function

Private Property Let iExport_FileName(RHS As String)
    mFileName = RHS
    If Right$(LCase$(mFileName), Len(mExtension)) <> mExtension Then mFileName = mFileName & mExtension
End Property

Private Property Get iExport_FileExtension() As String
    iExport_FileExtension = mExtension
End Property

Private Property Get iExport_FileName() As String
    iExport_FileName = mFileName
End Property

Private Property Set iExport_Legende(RHS As RC6.cRecordset)
    Set mLegende = RHS
End Property

Private Property Get iExport_Legende() As RC6.cRecordset
    Set iExport_Legende = mLegende
End Property

Private Property Set iExport_Recordset(RHS As RC6.cRecordset)
    Set mRs = RHS
End Property

Private Property Get iExport_Recordset() As RC6.cRecordset
    Set iExport_Recordset = mRs
End Property

Private Property Get iExport_Filter() As String
    iExport_Filter = mFilter
End Property





