VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cfUrlaubsplaner"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private WithEvents mfUrlaubsplaner As cWidgetForm       'Presenter
Attribute mfUrlaubsplaner.VB_VarHelpID = -1
Private WithEvents mWV As cWebView2                     'Browser
Attribute mWV.VB_VarHelpID = -1
Private mvDocument As iDocument                         'View
Attribute mvDocument.VB_VarHelpID = -1
Private mUrlaubsplaner As iData                         'Model
Private mFileName As String                             'Datei
Private mSkin As SkinConstants                          'Skin
Private Declare Function GetAsyncKeyState Lib "user32.dll" (ByVal nVirtKey As Long) As Long


Private Sub Class_Initialize()
Dim w As Long, h As Long
    w = GetSetting(App.ProductName, "Settings", "Width", 1280)
    h = GetSetting(App.ProductName, "Settings", "Height", 720)
    mSkin = GetSetting(App.ProductName, "Settings", "Skin", 0)
    Set mfUrlaubsplaner = Cairo.WidgetForms.Create(Width:=w, Height:=h)
    mfUrlaubsplaner.IconImageKey = "progIcn" 'Fenster-Icon
End Sub


Public Function Show(Optional Modal As FormShowConstants, Optional OwnerForm As Object, Optional ShowNonFocused As Boolean) As Boolean
Dim ret As Long
Dim fso As cFSO
Dim installPath As String
Dim file As String

    With mfUrlaubsplaner
        If App.LogMode Then
            .CenterOn mfUrlaubsplaner.WidgetRoot.CurrentMonitor
        Else
            .CenterOn New_c.Displays.Primary
            .Move 60, 60
        End If
        .Show Modal, OwnerForm, ShowNonFocused
        .Caption = "Urlaubsplaner"
    End With
    
    'Browser anbinden
    Set fso = New_c.fso
    Set mWV = New_c.WebView2
    Do
        If Len(VW2Path) > 0 Then
            ret = mWV.BindTo(mfUrlaubsplaner.hWnd, 4, VW2Path, fso.GetLocalAppDataPath & "\" & App.ProductName, "--lang=de")
            If ret = 0 Then
                MsgBox "Die WiewView2 Komponente konnte nicht geladen werden!" & vbCrLf & _
                    "Die Anwendung versucht die WiewView2 EverGreen-Version zu verwenden.", vbInformation, App.ProductName
                ret = mWV.BindTo(mfUrlaubsplaner.hWnd, 4, , fso.GetLocalAppDataPath & "\" & App.ProductName, "--lang=de")
            End If
        Else
            On Error Resume Next
            ret = mWV.BindTo(mfUrlaubsplaner.hWnd, 4, , fso.GetLocalAppDataPath & "\" & App.ProductName, "--lang=de")
        End If

        If ret = 0 Then
            installPath = AppPath & IIf(App.LogMode, "", "Bin\") & "MicrosoftEdgeWebview2Setup.exe"
            If Len(mWV.GetMostRecentInstallPath) = 0 And fso.FileExists(installPath) Then
                If MsgBox("Die WebView-Komponente konnte nicht initialisiert werden! " & _
                       "Vermutlich ist die WebView2-Runtime auf Ihrem System nicht installiert. " & _
                       "Mchten Sie die Runtime jetzt installieren?", vbQuestion + vbYesNo + vbDefaultButton1, "WebView2-Runtime installieren...") = vbYes Then
                    VW2Path = ""
                    If Not Installer.InstallWebView2(installPath) Then Exit Function
                Else
                    Exit Function
                End If
            Else
                MsgBox "Die WebView-Komponente konnte nicht initialisiert werden!", vbCritical, "Urlaubsplaner"
                Exit Function
            End If
        End If
    Loop While ret = 0
    On Error GoTo 0
    mWV.IsStatusBarEnabled = False
    If Not (App.LogMode = 0 Or mMain.Debugger) Then
        mWV.AreDefaultContextMenusEnabled = False
        mWV.AreDevToolsEnabled = False
    End If
    file = GetSetting(App.ProductName, "Settings", "LastFile", "")
    If Not fso.FileExists(file) Then file = ""

    Set mUrlaubsplaner = New cmUrlaubsplaner
    If Len(file) = 0 Then
        Call newFile        'Start mit Neu
    Else
        Call openFile(file) 'Start mit Urlaubsplaner
    End If
    Show = True


End Function


Private Sub mWV_DocumentComplete()
Dim vUrlaubsplaner As cvUrlaubsplaner
Dim vOptionen As cvOptionen
Dim progSettings As RC6.cHashD
    On Error GoTo mWV_DocumentComplete_Error
    If TypeOf mvDocument Is cvNeu Then
        mWV.jsProp("document.getElementById('txtJahr').value") = Year(Now)
        mWV.ExecuteScript "document.getElementById('txtJahr').focus()"
    ElseIf TypeOf mvDocument Is cvUrlaubsplaner Then
        Set vUrlaubsplaner = mvDocument
        With vUrlaubsplaner
            .ShowPersonen mUrlaubsplaner.GetPersonen
            .ShowKalender mUrlaubsplaner.GetKalender
            .ShowUrlaub mUrlaubsplaner.GetUrlaub
        End With
    ElseIf TypeOf mvDocument Is cvOptionen Then
        Set progSettings = New_c.HashD
        With progSettings
            .Add "CsvTemplate", GetSetting(App.ProductName, "Settings", "CsvTemplate", "<kz>;<name>;<datum>")
            .Add "PdfFormat", GetSetting(App.ProductName, "Settings", "PdfFormat", 0)
            .Add "OpenFile", GetSetting(App.ProductName, "Settings", "OpenFile", True)
            .Add "Skin", mSkin
        End With
        Set vOptionen = mvDocument
        With vOptionen
            .ShowSettings mUrlaubsplaner.GetSettings, progSettings
            .ShowFeiertage mUrlaubsplaner.GetFeiertage, mUrlaubsplaner.GetJahr
            .ShowFerien mUrlaubsplaner.GetFerien, mUrlaubsplaner.GetJahr
            .ShowBetriebsurlaub mUrlaubsplaner.GetBetriebsurlaub, mUrlaubsplaner.GetJahr
            mWV.ExecuteScript "document.getElementById('txtSlots').focus()"
        End With
    End If
    Exit Sub
    
mWV_DocumentComplete_Error:
    Screen.MousePointer = vbDefault
    MsgBox Err.Description, vbCritical
End Sub

Private Sub mWV_JSMessage(ByVal sMsg As String, ByVal sMsgContent As String, oJSONContent As RC6.cCollection)
Dim i As Integer
Dim bl As eBundeslaender
Dim exporter As iExport
Dim vUrlaubsplaner As cvUrlaubsplaner
Dim hdSettings As RC6.cHashD
Dim errors As cArrayList
    On Error GoTo mWV_JSMessage_Error
    If TypeOf mvDocument Is cvUrlaubsplaner Then Set vUrlaubsplaner = mvDocument
    Select Case sMsg
    '===Urlaubsplaner===
    Case "urlaubsplaner.tdClick"
        toggleUrlaubstag sMsgContent, vUrlaubsplaner.CurrentPersonId
        
    Case "urlaubsplaner.mnuClick"
        Select Case sMsgContent
            Case "mnuNew":      If checkForChangedData Then Call newFile
            Case "mnuOpen":     If checkForChangedData Then Call openFile
            Case "mnuSave":     Call saveFile: mWV.jsRun "closeNav"
            Case "mnuSaveAs":   Call saveFile(True): mWV.jsRun "closeNav"
            Case "mnuPrint":    Call printPage
            Case "mnuDefrag":   Call defragSlots
            Case "mnuOpt":      Call showOptionen
            Case "mnuClose":    mfUrlaubsplaner.Unload
        End Select
        
    Case "personen.save"
        If mUrlaubsplaner.SavePersonen(oJSONContent, errors) Then
            vUrlaubsplaner.ShowPersonen mUrlaubsplaner.GetPersonen
            vUrlaubsplaner.ShowUrlaub mUrlaubsplaner.GetUrlaub
        Else
            If errors.Count > 0 Then mWV.ExecuteScript "notification('" & errors.Join("<br>") & "')"
        End If
        
    Case "urlaubsplaner.radClick"
        If Left$(sMsgContent, 6) = "radSel" Then
            vUrlaubsplaner.CurrentPersonId = CLng(Mid$(sMsgContent, 7))
        End If
        
    Case "urlaubsplaner.btnClick"
        Select Case sMsgContent
        Case "btnCollapse"
            vUrlaubsplaner.PersonenCollapsed = Not vUrlaubsplaner.PersonenCollapsed
            vUrlaubsplaner.ShowPersonen mUrlaubsplaner.GetPersonen
        Case "btnDelete"
            mUrlaubsplaner.DeletePerson vUrlaubsplaner.CurrentPersonId
            With vUrlaubsplaner
                .CurrentPersonId = 0
                .ShowPersonen mUrlaubsplaner.GetPersonen
                .ShowUrlaub mUrlaubsplaner.GetUrlaub
            End With
        End Select
        
    Case "urlaubsplaner.selClick"
        If sMsgContent = "selPerson" Then
            i = CInt(mWV.jsProp("document.getElementById('selPerson').value"))
            If vUrlaubsplaner.CurrentPersonId <> i Then
                vUrlaubsplaner.CurrentPersonId = i
                vUrlaubsplaner.ShowPersonen mUrlaubsplaner.GetPersonen
            End If
        End If
    '===Neu===
    Case "neu.Click"
        Select Case sMsgContent
        Case "btnCancel"
            If mUrlaubsplaner.GetJahr > 0 Then
                Set mvDocument = New cvUrlaubsplaner
                mvDocument.LoadPage mWV, mUrlaubsplaner.GetSettings, mSkin
            Else
                mfUrlaubsplaner.Unload
            End If
        Case "btnSave"
            i = CInt(mWV.jsProp("document.getElementById('txtJahr').value"))
            bl = CLng(mWV.jsProp("document.getElementById('selLand').value"))
            Call createFile(i, bl)
        Case "fileOpen"
            Call openFile
        Case "fileImport"
            i = CInt(mWV.jsProp("document.getElementById('txtJahr').value"))
            bl = CLng(mWV.jsProp("document.getElementById('selLand').value"))
            Call importPersonen(i, bl)
        End Select
    '===Optionen===
    Case "optionen.btnClick"
        Select Case sMsgContent
        Case "btnCancel"
            Set mvDocument = New cvUrlaubsplaner
            mvDocument.LoadPage mWV, mUrlaubsplaner.GetSettings, mSkin
        Case "ipFeiertage", "ipFerien", "ipUrlaub"
            importKalendertage sMsgContent
        Case "btnHTMLExport"
            Set exporter = New cExportHtml
            Set hdSettings = New_c.HashD
            With mUrlaubsplaner.GetSettings
                hdSettings.Add "jahr", .fields("jahr").Value
                hdSettings.Add "slots", .fields("slots").Value
                hdSettings.Add "cFeiertag", .fields("cfeiertag").Value
                hdSettings.Add "cFerien", .fields("cferien").Value
                hdSettings.Add "cUrlaub", .fields("curlaub").Value
            End With
            Set exporter.Legende = mUrlaubsplaner.GetPersonen
            Set exporter.Recordset = mUrlaubsplaner.GetUrlaubskalender
            Call exportFile(exporter, hdSettings, mWV.jsProp("document.getElementById('chkOpen').checked") = True)
        Case "btnPDFExport", "btnBildExport"
            Set hdSettings = New_c.HashD
            If sMsgContent = "btnPDFExport" Then Set exporter = New cExportPdf Else Set exporter = New cExportJpg
            With mUrlaubsplaner.GetSettings
                hdSettings.Add "jahr", .fields("jahr").Value
                hdSettings.Add "slots", .fields("slots").Value
                hdSettings.Add "cFeiertag", .fields("cfeiertag").Value
                hdSettings.Add "cFerien", .fields("cferien").Value
                hdSettings.Add "cUrlaub", .fields("curlaub").Value
            End With
            hdSettings.Add "format", mWV.jsProp("document.getElementById('selPDF').value")
            Set exporter.Legende = mUrlaubsplaner.GetPersonen
            Set exporter.Recordset = mUrlaubsplaner.GetUrlaubskalender
            Call exportFile(exporter, hdSettings, mWV.jsProp("document.getElementById('chkOpen').checked") = True)
        Case "btnCSVExport"
            Set exporter = New cExportCsv
            Set hdSettings = New_c.HashD
            hdSettings.Add "template", mWV.jsProp("document.getElementById('txtCSV').value")
            Set exporter.Legende = mUrlaubsplaner.GetPersonen
            Set exporter.Recordset = mUrlaubsplaner.GetUrlaub
            Call exportFile(exporter, hdSettings, mWV.jsProp("document.getElementById('chkOpen').checked") = True)
        End Select
        
    Case "optionen.save"
        If mUrlaubsplaner.SaveOptionen(oJSONContent, errors) Then
            Set mvDocument = New cvUrlaubsplaner
            If oJSONContent.Exists("pdf") Then SaveSetting App.ProductName, "Settings", "PdfFormat", CInt(oJSONContent("pdf"))
            If oJSONContent.Exists("csv") Then SaveSetting App.ProductName, "Settings", "CsvTemplate", CStr(oJSONContent("csv"))
            If oJSONContent.Exists("open") Then SaveSetting App.ProductName, "Settings", "OpenFile", oJSONContent("open")
            If oJSONContent.Exists("skin") Then Skin = CInt(oJSONContent("skin"))
            mvDocument.LoadPage mWV, mUrlaubsplaner.GetSettings, mSkin
        Else
            Debug.Print "notification('" & errors.Join("<br>") & "')"
            mWV.ExecuteScript "notification('" & errors.Join("<br>") & "')"
        End If

    End Select
            
Exit Sub

mWV_JSMessage_Error:
    Screen.MousePointer = vbDefault
    MsgBox Err.Description, vbCritical
End Sub


Private Sub toggleUrlaubstag(id As String, id_person As Long)
Dim id_kalender As Long, slot As Integer, verplant As Single, ueberzogen As Boolean
Dim i As Integer
Dim vUrlaubsplaner As cvUrlaubsplaner
    Set vUrlaubsplaner = mvDocument
    i = InStr(id, "_")
    id_kalender = CLng(Left$(id, i - 1))
    slot = CInt(Mid$(id, i + 1))
    If mUrlaubsplaner.ToggleUrlaub(id_kalender, id_person, slot, verplant, ueberzogen) Then
        vUrlaubsplaner.RefreshTag mUrlaubsplaner.GetTag(id_kalender), id_kalender
        vUrlaubsplaner.RefreshVerplant verplant, ueberzogen, id_person
    End If
End Sub

Private Sub newFile()
    Set mvDocument = New cvNeu
    mvDocument.LoadPage mWV, mUrlaubsplaner.GetSettings, mSkin
End Sub

Private Sub createFile(Jahr As Integer, bundesland As eBundeslaender)
    Set mUrlaubsplaner = New cmUrlaubsplaner
    mUrlaubsplaner.NewKalender Jahr, bundesland
    FileName = ""
    Set mvDocument = New cvUrlaubsplaner
    mvDocument.LoadPage mWV, mUrlaubsplaner.GetSettings, mSkin
End Sub

Private Sub openFile(Optional file As String)
Dim fso As cFSO
Dim biv As Long, dbv As Long
Dim updateVer As Boolean
Dim Filter As String, defFolder As String
    On Error GoTo openFile_Error
    Set fso = New_c.fso
    If Len(file) = 0 Then
        If Len(mFileName) Then
            defFolder = fso.GetPathNameFromFullPath(mFileName)
        Else
            defFolder = GetSetting(App.ProductName, "Settings", "AppData", "")
            If Len(defFolder) = 0 Then defFolder = fso.GetLocalAppDataPath & "\" & App.ProductName
            If Not fso.FolderExists(defFolder) Then defFolder = fso.GetLocalAppDataPath
        End If
        Filter = "Urlaubsplaner (*.up)|*.up"
        file = fso.ShowOpenDialog(OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST, defFolder, "Urlaubsplaner ffnen...", , Filter, "up", mfUrlaubsplaner.hWnd)
        If Len(file) = 0 Then Exit Sub
    End If

    Set mUrlaubsplaner = New cmUrlaubsplaner
RESUME_OPEN:
    If mUrlaubsplaner.OpenKalender(file, biv, dbv, updateVer) Then
        FileName = file
        Set mvDocument = New cvUrlaubsplaner
        mvDocument.LoadPage mWV, mUrlaubsplaner.GetSettings, mSkin
        SaveSetting App.ProductName, "Settings", "LastFile", file
        SaveSetting App.ProductName, "Settings", "AppData", fso.GetPathNameFromFullPath(file)
    ElseIf biv > dbv Then
        If MsgBox("Die Datei " & fso.GetFileNameFromFullPath(file) & " hat eine alte Version!" & vbCrLf & "Mchten Sie diese Datei jetzt in die aktuelle Version konvertieren?", vbOKCancel + vbQuestion + vbDefaultButton1, "Datei konvertieren...") = vbOK Then
            updateVer = True
            GoTo RESUME_OPEN
        End If
    ElseIf biv < dbv Then
        MsgBox "Die Version der Datei " & fso.GetFileNameFromFullPath(file) & " ist neuer als die Programm-Version. Aktualisieren Sie Ihre Anwendung!", vbInformation, "Datei ffnen..."
    Else
        Call newFile
    End If
    Exit Sub
    
openFile_Error:
    Err.Raise Err.Number, "cfUrlaubsplaner.openFile." & Erl & vbCrLf & Err.Source, Err.Description
End Sub

Private Function importPersonen(Jahr As Integer, Optional bundesland As eBundeslaender) As Boolean
Dim fso As cFSO
Dim Filter As String, file As String, defFolder As String
    On Error GoTo importPersonen_Error
    Set fso = New_c.fso
    If Len(mFileName) Then
        defFolder = fso.GetPathNameFromFullPath(mFileName)
    Else
        defFolder = GetSetting(App.ProductName, "Settings", "AppData", "")
        If Len(defFolder) = 0 Then defFolder = fso.GetLocalAppDataPath & "\" & App.ProductName
        If Not fso.FolderExists(defFolder) Then defFolder = fso.GetLocalAppDataPath
    End If
    Filter = "Urlaubsplaner (*.up)|*.up"
    file = fso.ShowOpenDialog(OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST, defFolder, "Urlaubsplaner importieren...", , Filter, "up", mfUrlaubsplaner.hWnd)
    If Len(file) = 0 Then Exit Function
            

    Set mUrlaubsplaner = New cmUrlaubsplaner
    mFileName = ""
    If mUrlaubsplaner.ImportPersonenstamm(file, Jahr, bundesland) Then
        FileName = ""
        Set mvDocument = New cvUrlaubsplaner
        mvDocument.LoadPage mWV, mUrlaubsplaner.GetSettings, mSkin
        importPersonen = True
    End If
    Exit Function
    
importPersonen_Error:
    Err.Raise Err.Number, "cfUrlaubsplaner.importPersonen." & Erl & vbCrLf & Err.Source, Err.Description
End Function

Private Function importKalendertage(sMsgContent As String) As Boolean
Dim fso As cFSO
Dim Filter As String, file As String, defFolder As String
Dim vOptionen As cvOptionen
Dim impJahr As Integer
    On Error GoTo importPersonen_Error
    Set fso = New_c.fso
    If Len(mFileName) Then
        defFolder = fso.GetPathNameFromFullPath(mFileName)
    Else
        defFolder = GetSetting(App.ProductName, "Settings", "AppData", "")
        If Len(defFolder) = 0 Then defFolder = fso.GetLocalAppDataPath & "\" & App.ProductName
        If Not fso.FolderExists(defFolder) Then defFolder = fso.GetLocalAppDataPath
    End If
    Filter = "Urlaubsplaner (*.up)|*.up"
    file = fso.ShowOpenDialog(OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST, defFolder, "Kalenderdaten importieren...", , Filter, "up", mfUrlaubsplaner.hWnd)
    If Len(file) = 0 Then Exit Function
    
    Dim rs As cRecordset
    Set rs = mUrlaubsplaner.ImportKalender(sMsgContent, impJahr, file)
    If rs.RecordCount = 0 Then
        MsgBox "In der gewhlten Datei wurden keine passende Daten fr den Import gefunden!", vbInformation, "Import..."
        Exit Function
    End If
    If impJahr <> mUrlaubsplaner.GetJahr Then
        If MsgBox("Der Kalender der Import-Datei ist aus dem Jahr " & impJahr & ". Der aktuelle Urlaubsplaner wurde hingegen fr das Jahr " & mUrlaubsplaner.GetJahr & " angelegt. " & _
                  "Einige der importierten Datenstze werden vermutlich nicht korrekt sein." & vbCrLf & vbCrLf & "Mchten Sie denoch fortfahren?", vbExclamation Or vbYesNo Or vbDefaultButton2, "Import...") = vbNo Then Exit Function
    End If
    Set vOptionen = mvDocument
    Select Case sMsgContent
        Case "ipFeiertage"
            If MsgBox(rs.RecordCount & " Feiertage gefunden." & vbCrLf & "Sollen die vorhandenen Feiertage ersetzt werden?", vbQuestion + vbYesNo, "Feiertage importieren...") = vbNo Then Exit Function
            vOptionen.ShowFeiertage rs, mUrlaubsplaner.GetJahr
        Case "ipFerien"
            If MsgBox(rs.RecordCount & " Ferien gefunden." & vbCrLf & "Sollen die vorhandenen Ferien ersetzt werden?", vbQuestion + vbYesNo, "Ferien importieren...") = vbNo Then Exit Function
            vOptionen.ShowFerien rs, mUrlaubsplaner.GetJahr
        Case "ipUrlaub"
            If MsgBox(rs.RecordCount & " Datenstze gefunden." & vbCrLf & "Sollen die vorhandenen Betriebsurlaubstage ersetzt werden?", vbQuestion + vbYesNo, "Betriebsurlaub importieren...") = vbNo Then Exit Function
            vOptionen.ShowBetriebsurlaub rs, mUrlaubsplaner.GetJahr
    End Select
    
    Exit Function
    
importPersonen_Error:
    Err.Raise Err.Number, "cfUrlaubsplaner.importPersonen." & Erl & vbCrLf & Err.Source, Err.Description
End Function

Private Function saveFile(Optional SaveAs As Boolean) As Boolean
Dim fso As cFSO
Dim Filter As String, file As String, defFolder As String

    On Error GoTo saveFile_Error
    Set fso = New_c.fso
    If Len(mFileName) > 0 Then file = mFileName
    Debug.Print CBool(GetAsyncKeyState(vbKeyShift) And &H8000)
    If Len(FileName) = 0 Or CBool(GetAsyncKeyState(vbKeyShift) And &H8000) Or SaveAs Then
        If App.LogMode = 0 Then
            defFolder = AppPath   'IDE
        Else
            defFolder = GetSetting(App.ProductName, "Settings", "AppData", "")
            If Len(defFolder) = 0 Then defFolder = fso.GetLocalAppDataPath & "\" & App.ProductName
            If Not fso.FolderExists(defFolder) Then defFolder = fso.GetLocalAppDataPath
        End If
        Filter = "Urlaubsplaner (*.up)|*.up"
        file = fso.ShowSaveDialog(OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST, defFolder, "Urlaubsplaner speichern...", file, Filter, "up", mfUrlaubsplaner.hWnd)
        If Len(file) = 0 Then Exit Function
        If Right$(LCase$(file), 3) <> ".up" Then file = file & ".up"
        If fso.FileExists(file) Then
            If MsgBox("Die Datei " & vbCrLf & file & vbCrLf & "existiert bereits. Mchten Sie diese Datei berschreiben?", _
                    vbQuestion + vbYesNo, "Speichern") = vbNo Then Exit Function
        End If
    End If
          
    If Len(file) = 0 Then Exit Function
    With fso
        mUrlaubsplaner.SaveKalender file
        SaveSetting App.ProductName, "Settings", "LastFile", file
        SaveSetting App.ProductName, "Settings", "AppData", .GetPathNameFromFullPath(file)
        FileName = file
    End With
    saveFile = True
    Exit Function
    
saveFile_Error:
    Err.Raise Err.Number, "cfUrlaubsplaner.saveFile." & Erl & vbCrLf & Err.Source, Err.Description
End Function

Private Sub exportFile(exporter As iExport, hdSettings As RC6.cHashD, Optional shellExec As Boolean)
Dim fso As cFSO
Dim file As String
Static defFolder As String
    On Error GoTo exportFile_Error
    Set fso = New_c.fso
    If Len(mFileName) > 0 Then file = fso.GetFileNameWithoutExtension(mFileName)
    
    file = fso.ShowSaveDialog(OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST, defFolder, "Urlaubsplaner exportieren...", file, exporter.Filter, , mfUrlaubsplaner.hWnd)
    If Len(file) = 0 Then Exit Sub
    exporter.FileName = file
    file = exporter.FileName
    If fso.FileExists(file) Then
        If MsgBox("Die Datei " & vbCrLf & file & vbCrLf & "existiert bereits. Mchten Sie diese Datei berschreiben?", _
                vbQuestion + vbYesNo, "Export") = vbNo Then Exit Sub
    End If
    If fso.FileExists(file) Then Kill file
    fso.WriteByteContent file, exporter.GetData(hdSettings)
    defFolder = fso.GetPathNameFromFullPath(file)
    If shellExec Then Call fso.ShellExecute(file)
    Exit Sub
    
exportFile_Error:
    Err.Raise Err.Number, "cfUrlaubsplaner.exportFile." & Erl & vbCrLf & Err.Source, Err.Description
End Sub


Private Sub showOptionen()
    Set mvDocument = New cvOptionen
    mvDocument.LoadPage mWV, mUrlaubsplaner.GetSettings, mSkin
End Sub

Private Sub printPage()
    mWV.jsRun "closeNav"
    mWV.ExecuteScript "window.print()"
End Sub

Private Sub defragSlots()
Dim vUrlaubsplaner As cvUrlaubsplaner
    mUrlaubsplaner.Defrag
    Set vUrlaubsplaner = mvDocument
    vUrlaubsplaner.ShowKalender mUrlaubsplaner.GetKalender
    vUrlaubsplaner.ShowUrlaub mUrlaubsplaner.GetUrlaub
End Sub

Private Function checkForChangedData() As Boolean
    If mUrlaubsplaner.DataChanged Then
        Select Case MsgBox("Der aktuelle Urlaubsplaner enthllt nderungen, die noch nicht gespeichert sind. Mchten Sie diese nderungen jetzt speichern?", vbQuestion + vbYesNoCancel, "Speichern...")
            Case vbYes:     If Not saveFile Then Exit Function
            Case vbCancel:  Exit Function
        End Select
    End If
    checkForChangedData = True
End Function

Private Sub mfUrlaubsplaner_QueryUnload(Cancel As Boolean, UnloadMode As QueryUnloadConstants)
    If checkForChangedData Then
        SaveSetting App.ProductName, "Settings", "Width", mfUrlaubsplaner.Width
        SaveSetting App.ProductName, "Settings", "Height", mfUrlaubsplaner.Height
    Else
        Cancel = True
    End If
End Sub


Private Sub mfUrlaubsplaner_GotFocus()
    On Error Resume Next
    If Not mWV Is Nothing Then mWV.SetFocus
End Sub

Private Sub mfUrlaubsplaner_Resize()
    If Not mWV Is Nothing Then mWV.SyncSizeToHostWindow
End Sub

Private Sub mfUrlaubsplaner_Unload(Cancel As Integer)
    If App.LogMode = 0 Then Unload fDummy
End Sub

Private Property Get FileName() As String
    FileName = mFileName
End Property

Private Property Let FileName(ByVal vNewValue As String)
Dim i As Integer
    mFileName = vNewValue
    If Len(vNewValue) = 0 Then
        mfUrlaubsplaner.Caption = "Ulaubsplaner " & mUrlaubsplaner.GetJahr
    Else
        mfUrlaubsplaner.Caption = "Ulaubsplaner " & mUrlaubsplaner.GetJahr & " - " & Left$(mFileName, InStr(3, mFileName, "\")) & "...\" & New_c.fso.GetFileNameFromFullPath(mFileName)
    End If
End Property

Public Property Get Skin() As SkinConstants
    Skin = mSkin
End Property

Public Property Let Skin(ByVal vNewValue As SkinConstants)
    On Error Resume Next
    If mSkin <> vNewValue Then
        SaveSetting App.ProductName, "Settings", "Skin", vNewValue
        mSkin = vNewValue
    End If
End Property



