VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmUrlaubsplaner"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements iData

Private Const CURRENT_DB_VER As Integer = 2
Private mCnn As cConnection
Private mJahr As Integer
Private minD As Date, maxD As Date

    
Private Sub Class_Initialize()
    Set mCnn = New_c.Connection
    mCnn.CreateNewDB ":memory:"
End Sub


'===Personen===
Private Function iData_GetPersonen(Optional id_person As Long) As cRecordset
Dim sSQL As String
sSQL = "SELECT " & _
       "   personen.id_person," & _
       "   personen.farbe," & _
       "   personen.kuerzel," & _
       "   personen.name," & _
       "   personen.kontingent," & _
       "   personen.kinder," & _
       "   COALESCE(SUM(urlaub.anteil),0) + (" & _
       "     SELECT" & _
       "       COALESCE(SUM(betriebsurlaub.anteil),0)" & _
       "     FROM" & _
       "       betriebsurlaub" & _
       "       INNER JOIN kalender ON betriebsurlaub.id_burlaub=kalender.id_burlaub" & _
       "   ) AS verplant" & _
       " FROM" & _
       "   personen" & _
       "   LEFT JOIN urlaub ON personen.id_person = urlaub.id_person "
       If id_person > 0 Then sSQL = sSQL & "WHERE personen.id_person = " & id_person
       sSQL = sSQL & _
       " GROUP BY" & _
       "   personen.id_person," & _
       "   personen.kuerzel," & _
       "   personen.name," & _
       "   personen.kontingent" & _
       " ORDER BY personen.name"
    Set iData_GetPersonen = mCnn.OpenRecordset(sSQL)
End Function

Private Function iData_DeletePerson(id_person As Long) As Boolean
    With mCnn
        .BeginTrans
        .Execute "DELETE FROM urlaub WHERE id_person=" & id_person
        iData_DeletePerson = CBool(.Execute("DELETE FROM personen WHERE id_person=" & id_person))
        .CommitTrans
    End With
End Function

Private Function iData_ImportKalender(Tage As String, Jahr As Integer, FileName As String) As cRecordset
    On Error GoTo ImportKalender_Error
    With New_c.Connection()
        .OpenDBReadOnly FileName
        With .OpenRecordset("SELECT TOP 1 datum FROM kalender")
            Jahr = Year(.fields(0).Value)
        End With
        
        Select Case Tage
            Case "ipFeiertage"
                Set iData_ImportKalender = .OpenRecordset("SELECT feiertage.id_feiertag, kalender.datum, feiertage.name FROM feiertage " & _
                                                "INNER JOIN kalender ON feiertage.id_feiertag = kalender.id_kalender " & _
                                                "ORDER BY feiertage.id_feiertag", True)
            Case "ipFerien"
                Set iData_ImportKalender = .OpenRecordset("SELECT ferien.id_ferien,k1.datum AS ferienstart,k2.datum AS ferienende,ferien.name FROM ferien " & _
                                                "LEFT JOIN kalender AS k1 ON ferien.id_ferien = k1.id_kalender " & _
                                                "LEFT JOIN kalender AS k2 ON ferien.id_ende = k2.id_kalender " & _
                                                "ORDER BY ferien.id_ferien", True)
            Case "ipUrlaub"
                Set iData_ImportKalender = .OpenRecordset("SELECT betriebsurlaub.id_burlaub,k1.datum AS bustart,k2.datum AS buende,betriebsurlaub.name,betriebsurlaub.anteil " & _
                                                "FROM betriebsurlaub " & _
                                                "INNER JOIN kalender AS k1 ON betriebsurlaub.id_burlaub = k1.id_kalender " & _
                                                "INNER JOIN kalender AS k2 ON betriebsurlaub.id_ende = k2.id_kalender " & _
                                                "ORDER BY betriebsurlaub.id_burlaub", True)
        End Select
    End With
    Exit Function
    
ImportKalender_Error:
    Err.Raise Err.Number, "cmUrlaubsplaner.ImportKalender." & Erl, "Ungltige Quelldatei!" & vbCrLf & Err.Description
    
End Function

Private Function iData_SavePersonen(data As RC6.cCollection, errors As cArrayList) As Boolean
Dim rs As cRecordset
Dim id As Long, kz As String, name As String, kontingent As Long
    Set errors = New_c.ArrayList(vbString)
    Set rs = mCnn.OpenRecordset("SELECT * FROM personen ORDER BY id_person")
    With data
        Do Until rs.EOF
            id = rs!id_person
            If .Exists("radSel" & id) Then
                rs!name = .item("txtName" & id)
                kz = .item("txtKz" & id)
                If Len(kz) = 0 Then kz = getKzFromName(rs!name)
                rs!kuerzel = kz
                rs!kontingent = CLng(.item("txtKontingent" & id))
                If rs!kontingent < 0 Or rs!kontingent > 99 Then rs!kontingent = 0
                rs!farbe = .item("col" & id)
                rs!kinder = CBool(.item("chkSk" & id))
            End If
            rs.MoveNext
        Loop
        If (Len(.item("txtName0")) > 0 Or Len(.item("txtKz0")) > 0) Then
            rs.AddNew
            rs!id_person = id + 1
            rs!name = .item("txtName0")
            kz = .item("txtKz0")
            If Len(kz) = 0 Then kz = getKzFromName(rs!name)
            rs!kuerzel = kz
            rs!kontingent = CLng(.item("txtKontingent0"))
            If rs!kontingent < 0 Or rs!kontingent > 99 Then rs!kontingent = 0
            rs!farbe = .item("col0")
            rs!kinder = CBool(.item("chkSk0"))
        End If
    End With
    If rs.ContainsChanges Then
        rs.UpdateBatch
        iData_SavePersonen = True
    End If
    
End Function

Private Function getKzFromName(name As String) As String
Dim kz() As String
Dim i As Integer
    If Len(name) > 0 Then
        kz = Split(name, " ")
        For i = 0 To UBound(kz)
            kz(i) = UCase(Left$(kz(i), 1))
        Next
        getKzFromName = Left$(Join(kz, ""), 2)
    Else
        getKzFromName = "??"
    End If
End Function

'===Optionen===
Private Function iData_GetSlots() As Integer
    With mCnn.OpenRecordset("SELECT slots FROM einstellungen")
        iData_GetSlots = .fields(0).Value
    End With
End Function

Private Function iData_GetSettings() As cRecordset
Dim rs As RC6.cRecordset
Dim minSlots As Integer
    On Error GoTo ErrGetSettings
    Set rs = mCnn.OpenRecordset("SELECT max(slot) FROM urlaub")
    If Not rs.EOF Then minSlots = rs.fields(0).Value
    If minSlots < 2 Then minSlots = 2
    Set iData_GetSettings = mCnn.OpenRecordset("SELECT " & mJahr & " AS jahr,slots,cfeiertag,cferien,curlaub," & minSlots & " AS minslots FROM einstellungen")
    Exit Function
ErrGetSettings:

End Function

Private Function iData_GetFeiertage() As cRecordset
    Set iData_GetFeiertage = mCnn.OpenRecordset("SELECT feiertage.id_feiertag, kalender.datum, feiertage.name FROM feiertage " & _
                                                "INNER JOIN kalender ON feiertage.id_feiertag = kalender.id_kalender " & _
                                                "ORDER BY feiertage.id_feiertag")
End Function

Private Function iData_GetFerien() As cRecordset
    Set iData_GetFerien = mCnn.OpenRecordset("SELECT ferien.id_ferien,k1.datum AS ferienstart,k2.datum AS ferienende,ferien.name FROM ferien " & _
                                             "LEFT JOIN kalender AS k1 ON ferien.id_ferien = k1.id_kalender " & _
                                             "LEFT JOIN kalender AS k2 ON ferien.id_ende = k2.id_kalender " & _
                                             "ORDER BY ferien.id_ferien")
End Function

Private Function iData_GetBetriebsurlaub() As cRecordset
    Set iData_GetBetriebsurlaub = mCnn.OpenRecordset("SELECT betriebsurlaub.id_burlaub,k1.datum AS bustart,k2.datum AS buende,betriebsurlaub.name,betriebsurlaub.anteil " & _
                                                "FROM betriebsurlaub " & _
                                                "INNER JOIN kalender AS k1 ON betriebsurlaub.id_burlaub = k1.id_kalender " & _
                                                "INNER JOIN kalender AS k2 ON betriebsurlaub.id_ende = k2.id_kalender " & _
                                                "ORDER BY betriebsurlaub.id_burlaub")
End Function


Private Function iData_SaveOptionen(data As RC6.cCollection, errors As cArrayList) As Boolean
Dim slots As Integer, minSlots As Integer
Dim cFeiertage As String, cFerien As String, cUrlaub As String
Dim rs As RC6.cRecordset
Dim cmd As cCommand

    Set rs = mCnn.OpenRecordset("SELECT max(slot) FROM urlaub")
    If Not rs.EOF Then minSlots = rs.fields(0).Value
    If minSlots < 2 Then minSlots = 2
    
    On Error GoTo ERR_SAVE_OPTIONEN
    cFeiertage = "#CCBBCC"
    cFerien = "#FFFF99"
    cUrlaub = "#CCFFDD"
    Set errors = New_c.ArrayList(vbString)
    mCnn.BeginTrans
    
    If data.Exists("slots") Then
        If IsNumeric(data("slots")) Then
            slots = CInt(data("slots"))
        Else
            Err.Raise vbObjectError, "Optionen", "Ungltige Eingabe in Slots!"
        End If
        If slots < minSlots Or slots > 30 Then
            If minSlots > 2 Then
                Err.Raise vbObjectError, "Optionen", "Slots ausserhalb des gltigen Bereichs von " & minSlots & " bis 30! " & _
                                                     "Vermutlich haben Sie in einem hherem Slot Urlaubstage geplant. " & _
                                                     "Sie knnen versuchen die Slots neu ordnen und so hhere Slots freimachen."
            Else
                Err.Raise vbObjectError, "Optionen", "Slots ausserhalb des gltigen Bereichs von 2 bis 30!"
            End If
        End If
    End If
    If data.Exists("cFeiertage") Then cFeiertage = data("cFeiertage")
    If data.Exists("cFerien") Then cFerien = data("cFerien")
    If data.Exists("cUrlaub") Then cUrlaub = data("cUrlaub")
    
    Set cmd = mCnn.CreateCommand("UPDATE einstellungen SET slots=?,cfeiertag=?,cferien=?,curlaub=?")
    With cmd
        .SetInt32 1, slots
        .SetText 2, cFeiertage
        .SetText 3, cFerien
        .SetText 4, cUrlaub
    End With
    cmd.Execute

    If data.Exists("feiertage") Then saveFeiertage data("feiertage"), errors
    If data.Exists("ferien") Then saveFerien data("ferien"), errors
    If data.Exists("urlaub") Then saveBetriebsurlaub data("urlaub"), errors

    If errors.Count = 0 Then
        mCnn.CommitTrans
        iData_SaveOptionen = True
    Else
        mCnn.RollbackTrans
    End If
    Exit Function
    
ERR_SAVE_OPTIONEN:
    errors.Add Err.Description
    On Error GoTo -1
    On Error Resume Next
    mCnn.RollbackTrans
    errors.Add HtmlHelper.Escape(Err.Description)
End Function

Private Sub saveBetriebsurlaub(items As RC6.cCollection, errors As cArrayList)
Dim item As RC6.cCollection
Const errCode As Long = 2079
Dim id As Long, name As String, datum(1) As Date
Dim rs As RC6.cRecordset

    On Error GoTo Err_saveBetriebsurlaub
    mCnn.Execute "DELETE FROM betriebsurlaub"
    mCnn.Execute "UPDATE kalender SET id_burlaub=0"
    
    For Each item In items
        id = CLng(item("id"))
        If IsDate(item("von")) Then
            datum(0) = item("von")
            If datum(0) < minD Or datum(0) > maxD Then Err.Raise vbObjectError + errCode, "Optionen", "Der Beriebsurlaubsanfang am <i>" & datum(0) & "</i> hat ein ungltiges Datum!"
        Else
            datum(0) = 0
            If Len(item("von")) > 0 Then Err.Raise vbObjectError + errCode, "Optionen", "Der Beriebsurlaubsanfang am <i>" & HtmlHelper.Escape(item("von")) & "</i> hat ein ungltiges Datumsformat!"
        End If
        If IsDate(item("bis")) Then
            datum(1) = item("bis")
            If datum(1) < minD Or datum(1) > maxD Then Err.Raise vbObjectError + errCode, "Optionen", "Das Beriebsurlaubsenende am <i>" & datum(1) & "</i> hat ein ungltiges Datum!"
        Else
            datum(1) = 0
            If Len(item("bis")) > 0 Then Err.Raise vbObjectError + errCode, "Optionen", "Das Beriebsurlaubsende am <i>" & HtmlHelper.Escape(item("datum")) & "</i> hat ein ungltiges Datumsformat!"
        End If
        name = Trim$(item("name"))
        If datum(1) = 0 Then datum(1) = datum(0)
        If datum(1) < datum(0) Then
            Err.Raise vbObjectError + errCode, "Optionen", "Der Beriebsurlaubsanfang am <i>" & HtmlHelper.Escape(item("datum")) & "</i> liegt hinter dem Beriebsurlaubsende!"
        End If
        If id <> CLng(datum(0)) Then id = CLng(datum(0))
        mCnn.ExecCmd "INSERT INTO betriebsurlaub (id_burlaub,name,id_ende,anteil) VALUES (?,?,?,1)", id, name, CLng(datum(1))
    Next

    Set rs = mCnn.OpenRecordset("SELECT id_burlaub,name,id_ende FROM betriebsurlaub ORDER BY id_burlaub")
    Do Until rs.EOF
        For id = rs!id_burlaub To rs!id_ende
            mCnn.Execute "UPDATE kalender SET id_burlaub=" & rs!id_burlaub & _
                         " WHERE id_kalender=" & id & _
                         " AND id_kalender NOT IN (SELECT id_feiertag from feiertage) " & _
                         " AND strftime('%w',datum) <> '0' AND strftime('%w',datum) <> '6'"
            mCnn.Execute "DELETE FROM urlaub WHERE id_kalender=" & id
        Next id
        rs.MoveNext
    Loop
    
    Exit Sub

    
Err_saveBetriebsurlaub:
    If Err.Number = vbObjectError + errCode Then
        errors.Add Err.Description
    ElseIf Err Then
        If InStr(Err.Description, "UNIQUE constraint failed") Then
            errors.Add "Beim Beriebsurlaub wurde der " & datum(0) & " mehrfach verwendet!"
        Else
            errors.Add Err.Description
        End If
    End If
End Sub

Private Sub saveFeiertage(items As RC6.cCollection, errors As cArrayList)
Dim item As RC6.cCollection
Const errCode As Long = 2077
Dim id As Long, name As String, datum As Date

    On Error GoTo Err_saveFeiertage
    mCnn.Execute "DELETE FROM feiertage"
    For Each item In items
        id = CLng(item("id"))
        If IsDate(item("datum")) Then
            datum = item("datum")
            If datum < minD Or datum > maxD Then Err.Raise vbObjectError + errCode, "Optionen", "Der Feiertag am <i>" & datum & "</i> hat ein ungltiges Datum!"
        Else
            datum = 0
            If Len(item("datum")) > 0 Then Err.Raise vbObjectError + errCode, "Optionen", "Der Feiertag am <i>" & HtmlHelper.Escape(item("datum")) & "</i> hat ein ungltiges Datumsformat!"
        End If
        name = Trim$(item("name"))
        If Len(name) = 0 Then
            If datum <> 0 Then Err.Raise vbObjectError + errCode, "Optionen", "Der Feiertag am <i>" & datum & "</i> hat keine Bezeichnung!"
        ElseIf Len(name) > 30 Then
            name = Left$(name, 30)
        End If
        If datum = 0 And Len(name) > 0 Then
            Err.Raise vbObjectError + errCode, "Optionen", "Der Feiertag <i>" & HtmlHelper.Escape(name) & "</i> hat ein ungltiges Datumsformat!"
        ElseIf datum > 0 And Len(name) > 0 Then
            If id <> CLng(datum) Then id = CLng(datum)
            mCnn.Execute "INSERT INTO feiertage(id_feiertag,name) VALUES (" & id & ",'" & name & "')"
            mCnn.Execute "DELETE FROM urlaub WHERE id_kalender = " & id
        End If
    Next
    Exit Sub
    
Err_saveFeiertage:
    If Err.Number = vbObjectError + errCode Then
        errors.Add Err.Description
    ElseIf Err Then
        If InStr(Err.Description, "UNIQUE constraint failed") Then
            errors.Add "Bei den Feiertagen wurde der <i>" & datum & "</i> mehrfach verwendet!"
        Else
            errors.Add HtmlHelper.Escape(Err.Description)
        End If
    End If

End Sub

Private Sub saveFerien(items As RC6.cCollection, errors As cArrayList)
Dim item As RC6.cCollection
Const errCode As Long = 2078
Dim id As Long, name As String, datum(1) As Date
Dim rs As RC6.cRecordset


    On Error GoTo Err_saveFerien
    mCnn.Execute "DELETE FROM ferien"
    mCnn.Execute "UPDATE kalender SET id_ferien=0"
    For Each item In items
        id = CLng(item("id"))
        name = Trim$(item("name"))
        If IsDate(item("von")) Then
            datum(0) = item("von")
            If datum(0) < minD Or datum(0) > maxD Then Err.Raise vbObjectError + errCode, "Optionen", "Der Ferienanfang am <i>" & datum(0) & "</i> ist ungltig!"
        Else
            datum(0) = 0
            If id < 0 Then
                'nichts tun -> Dummy
            ElseIf Len(item("von")) > 0 Then
                Err.Raise vbObjectError + errCode, "Optionen", "Der Ferienanfang am <i>" & HtmlHelper.Escape(item("von")) & "</i> ist ungltig!"
            Else
                Err.Raise vbObjectError + errCode, "Optionen", "Der Ferienanfang fr <i>" & HtmlHelper.Escape(name) & "</i> ist ungltig!"
            End If
        End If
        If IsDate(item("bis")) Then
            datum(1) = item("bis")
            If datum(1) < minD Or datum(1) > maxD Then Err.Raise vbObjectError + errCode, "Optionen", "Das Ferienende am <i>" & datum(1) & "</i> ist ungltig!"
        Else
            datum(1) = 0
            If id < 0 And datum(0) = 0 Then
                'nichts tun -> Dummy
            ElseIf Len(item("bis")) > 0 Then
                Err.Raise vbObjectError + errCode, "Optionen", "Das Ferienende fr <i>" & HtmlHelper.Escape(item("bis")) & "</i> ist ungltig!"
            Else
                Err.Raise vbObjectError + errCode, "Optionen", "Das Ferienende fr <i>" & HtmlHelper.Escape(name) & "</i> ist ungltig!"
            End If
        End If
        
        If datum(1) = 0 Then datum(1) = datum(0)
        If datum(1) < datum(0) Then
            Err.Raise vbObjectError + errCode, "Optionen", "Der Ferienanfang am <i>" & HtmlHelper.Escape(CStr(datum(0))) & "</i> liegt hinter dem Ferienende!"
        End If
        If id <> CLng(datum(0)) Then id = CLng(datum(0))
        If id > 0 Then mCnn.Execute "INSERT INTO ferien(id_ferien,name,id_ende) VALUES (" & id & ",'" & name & "'," & CLng(datum(1)) & ")"
    Next
    Set rs = mCnn.OpenRecordset("SELECT id_ferien,id_ende FROM ferien WHERE id_ferien > 0 ORDER BY id_ferien")
    Do Until rs.EOF
        For id = rs!id_ferien To rs!id_ende
            mCnn.Execute "UPDATE kalender SET id_ferien=" & rs!id_ferien & " WHERE id_kalender=" & id
        Next id
        rs.MoveNext
    Loop
    
    Exit Sub
    
Err_saveFerien:
    If Err.Number = vbObjectError + errCode Then
        errors.Add Err.Description
        Resume Next
    ElseIf Err Then
        If InStr(Err.Description, "UNIQUE constraint failed") Then
            errors.Add "Bei den Ferien wurde der " & CDate(id) & " mehrfach verwendet!"
        Else
            errors.Add Err.Description
        End If
    End If
End Sub


'===Kalender===
Private Function iData_GetJahr() As Long
    iData_GetJahr = mJahr
End Function

Private Function iData_GetKalender() As cRecordset
Dim sSQL As String
    sSQL = "SELECT id_kalender,datum," & _
        "CAST(strftime('%d',datum) AS INTEGER) AS tag," & _
        "CAST(strftime('%m',datum) AS INTEGER) AS monat," & _
        "CASE strftime('%w',datum) " & _
        "WHEN '0' THEN 'So' " & _
        "WHEN '1' THEN 'Mo' " & _
        "WHEN '2' THEN 'Di' " & _
        "WHEN '3' THEN 'Mi' " & _
        "WHEN '4' THEN 'Do' " & _
        "WHEN '5' THEN 'Fr' " & _
        "WHEN '6' THEN 'Sa' " & _
        "END AS wtag," & _
        "CASE strftime('%w',datum) " & _
        "WHEN '0' THEN 1 " & _
        "WHEN '6' THEN 1 " & _
        "ELSE 0 " & _
        "END AS we," & _
        "feiertage.name AS feiertag,ferien.id_ferien,betriebsurlaub.name AS burlaub " & _
        "From kalender " & _
        "LEFT JOIN feiertage ON kalender.id_kalender = feiertage.id_feiertag " & _
        "LEFT JOIN ferien ON kalender.id_ferien = ferien.id_ferien " & _
        "LEFT JOIN betriebsurlaub ON (kalender.id_burlaub = betriebsurlaub.id_burlaub) " & _
        "ORDER BY tag, monat"
    Set iData_GetKalender = mCnn.OpenRecordset(sSQL)

End Function

Private Sub iData_NewKalender(Jahr As Integer, Optional bundesland As eBundeslaender)
Dim d As Date
Dim rs As cRecordset

        mJahr = Jahr
        minD = DateSerial(Jahr, 1, 1)
        maxD = DateSerial(Jahr, 12, 31)
                
        mCnn.Execute "CREATE TABLE IF NOT EXISTS einstellungen (" & _
            "ver         INTEGER NOT NULL DEFAULT " & CURRENT_DB_VER & "," & _
            "land        INTEGER NOT NULL DEFAULT 0," & _
            "cfeiertag   TEXT(7) NOT NULL DEFAULT '#CCBBCC'," & _
            "cferien     TEXT(7) NOT NULL DEFAULT '#FFFF99'," & _
            "curlaub     TEXT(7) NOT NULL DEFAULT '#CCFFDD'," & _
            "slots       INTEGER NOT NULL DEFAULT 2)"
            mCnn.Execute "UPDATE einstellungen SET land=" & bundesland
            If mCnn.AffectedRows = 0 Then
                mCnn.Execute "INSERT INTO einstellungen(land) VALUES (" & bundesland & ")"
            End If
            
        mCnn.Execute "CREATE TABLE IF NOT EXISTS personen (" & _
            "id_person  INTEGER NOT NULL DEFAULT 0," & _
            "farbe      TEXT(7) NOT NULL DEFAULT ''," & _
            "kuerzel    TEXT(2) NOT NULL DEFAULT ''," & _
            "name       TEXT(30) NOT NULL DEFAULT ''," & _
            "kontingent FLOAT NOT NULL DEFAULT 0," & _
            "kinder     BOOLEAN NOT NULL DEFAULT FALSE," & _
            "PRIMARY KEY (id_person))"
            
        mCnn.Execute "CREATE TABLE IF NOT EXISTS kalender (" & _
            "id_kalender INTEGER NOT NULL DEFAULT 0," & _
            "datum       SHORTDATE NOT NULL DEFAULT 0," & _
            "id_ferien   INTEGER, " & _
            "id_burlaub  INTEGER, " & _
            "PRIMARY KEY (id_kalender))"
            mCnn.Execute "DELETE FROM kalender"
            
        mCnn.Execute "CREATE TABLE IF NOT EXISTS feiertage (" & _
            "id_feiertag INTEGER NOT NULL DEFAULT 0," & _
            "name        TEXT(30) NOT NULL DEFAULT ''," & _
            "PRIMARY KEY (id_feiertag))"
            mCnn.Execute "DELETE FROM feiertage"

        mCnn.Execute "CREATE TABLE IF NOT EXISTS ferien (" & _
            "id_ferien  INTEGER NOT NULL DEFAULT 0," & _
            "id_ende    INTEGER NOT NULL DEFAULT 0," & _
            "name       TEXT(30) NOT NULL DEFAULT ''," & _
            "PRIMARY KEY (id_ferien))"
            mCnn.Execute "DELETE FROM ferien"
            mCnn.Execute "INSERT INTO ferien (id_ferien,name) VALUES " & _
                "(-7,'Neujahr')," & _
                "(-6,'Winter')," & _
                "(-5,'Ostern')," & _
                "(-4,'Pfingsten')," & _
                "(-3,'Sommer')," & _
                "(-2,'Herbst')," & _
                "(-1,'Weihnachten')"
            
        mCnn.Execute "CREATE TABLE IF NOT EXISTS betriebsurlaub (" & _
            "id_burlaub  INTEGER NOT NULL DEFAULT 0," & _
            "id_ende     INTEGER NOT NULL DEFAULT 0," & _
            "name        TEXT(30) NOT NULL DEFAULT ''," & _
            "anteil      FLOAT NOT NULL DEFAULT 1," & _
            "PRIMARY KEY (id_burlaub))"
            mCnn.Execute "DELETE FROM betriebsurlaub"
            
        mCnn.Execute "CREATE TABLE IF NOT EXISTS urlaub (" & _
            "id_kalender INTEGER NOT NULL DEFAULT 0," & _
            "id_person   INTEGER NOT NULL DEFAULT 0," & _
            "slot        INTEGER NOT NULL DEFAULT 0," & _
            "anteil      FLOAT NOT NULL DEFAULT 1," & _
            "PRIMARY KEY (id_kalender,id_person)," & _
            "FOREIGN KEY (id_kalender) REFERENCES kalender(id_kalender)," & _
            "FOREIGN KEY (id_person)   REFERENCES personen(id_person))"
            mCnn.Execute "CREATE UNIQUE INDEX IF NOT EXISTS ixslotbelegung ON urlaub (id_kalender,slot)"
            mCnn.Execute "DELETE FROM urlaub"

        Set rs = mCnn.OpenRecordset("SELECT * FROM kalender")
        For d = minD To maxD
            rs.AddNew
            rs!id_kalender = CLng(d)
            rs!datum = d
        Next d
        rs.UpdateBatch
        'Feiertage berechnen
        If bundesland > 0 Then
            Set rs = mCnn.OpenRecordset("SELECT * FROM feiertage")
            rs.AddNew: rs!id_feiertag = CLng(DateSerial(mJahr, 1, 1)): rs!name = "Neujahr"
            d = ostersonntag()
            rs.AddNew: rs!id_feiertag = CLng(d): rs!name = "Osterson."
            rs.AddNew: rs!id_feiertag = CLng(DateAdd("d", -2, d)): rs!name = "Karfreitag"
            rs.AddNew: rs!id_feiertag = CLng(DateAdd("d", 1, d)): rs!name = "Ostermon."
            rs.AddNew: rs!id_feiertag = CLng(DateAdd("d", 39, d)): rs!name = "Ch-Himmelf."
            rs.AddNew: rs!id_feiertag = CLng(DateAdd("d", 49, d)): rs!name = "Pfingstson."
            rs.AddNew: rs!id_feiertag = CLng(DateAdd("d", 50, d)): rs!name = "Pfingstmon."
            rs.AddNew: rs!id_feiertag = CLng(DateSerial(mJahr, 5, 1)): rs!name = "Maifeiertag"
            If (bundesland And (eBundeslaender.blBadenWuerttemberg Or eBundeslaender.blBayern Or eBundeslaender.blSachsenAnhalt)) = bundesland Then
                rs.AddNew: rs!id_feiertag = CLng(DateSerial(mJahr, 1, 6)): rs!name = "Erscheinung"
            End If
            If (bundesland And (eBundeslaender.blBadenWuerttemberg Or eBundeslaender.blBayern Or eBundeslaender.blHessen Or _
                                eBundeslaender.blNordrheinWestfalen Or eBundeslaender.blRheinlandPfalz Or eBundeslaender.blSaarland)) = bundesland Then
                rs.AddNew: rs!id_feiertag = CLng(DateAdd("d", 60, d)): rs!name = "Fronleichnam"
            End If
            If (bundesland And (eBundeslaender.blSaarland)) = bundesland Then
                rs.AddNew: rs!id_feiertag = CLng(DateSerial(mJahr, 8, 15)): rs!name = "M-Himmelf."
            End If
            rs.AddNew: rs!id_feiertag = CLng(DateSerial(mJahr, 10, 3)): rs!name = "Einheitstag"
            If (bundesland And (eBundeslaender.blBrandenburg Or eBundeslaender.blMecklenburgVorpommern Or eBundeslaender.blSachsen Or _
                                eBundeslaender.blSachsenAnhalt Or eBundeslaender.blThueringen)) = bundesland Then
                rs.AddNew: rs!id_feiertag = CLng(DateSerial(mJahr, 10, 31)): rs!name = "Reformation"
            End If
            If (bundesland And (eBundeslaender.blBadenWuerttemberg Or eBundeslaender.blBayern Or eBundeslaender.blNordrheinWestfalen Or _
                                eBundeslaender.blRheinlandPfalz Or eBundeslaender.blSaarland)) = bundesland Then
                rs.AddNew: rs!id_feiertag = CLng(DateSerial(mJahr, 11, 1)): rs!name = "Allerh."
            End If
            If (bundesland And (eBundeslaender.blSachsen)) = bundesland Then
                maxD = DateSerial(mJahr, 12, 25)
                maxD = (Weekday(maxD) * -1) - 28
                maxD = maxD + (-1 * vbWednesday)
                rs.AddNew: rs!id_feiertag = CLng(maxD): rs!name = "Bu- und Bettag"
            End If
            rs.AddNew: rs!id_feiertag = CLng(DateSerial(mJahr, 12, 25)): rs!name = "Weihnachten"
            rs.AddNew: rs!id_feiertag = CLng(DateSerial(mJahr, 12, 26)): rs!name = "Weihnachten"
            rs.UpdateBatch
        End If
    
End Sub

Private Function ostersonntag() As Date
    'Osterfunktion nach Carl Friedrich Gau (1800). Rckgabewert ist das Datum des Ostersonntags im angegebenen
    '(ersatzweise: aktuellen) Jahr. Gltigkeitsbereich: 1583 - 8702
    Dim a As Integer, b As Integer, c As Integer, d As Integer, e As Integer, F As Integer
    ' Die "magische" Gauss-Formel anwenden:
    a = mJahr Mod 19
    b = mJahr \ 100
    c = (8 * b + 13) \ 25 - 2
    d = b - (mJahr \ 400) - 2
    e = (19 * (mJahr Mod 19) + ((15 - c + d) Mod 30)) Mod 30
    If e = 28 Then
        If a > 10 Then
            e = 27
        End If
    ElseIf e = 29 Then
        e = 28
    End If
    F = (d + 6 * e + 2 * (mJahr Mod 4) + 4 * (mJahr Mod 7) + 6) Mod 7
    ' Rckgabewert als Datum bereitstellen
    ostersonntag = DateSerial(mJahr, 3, e + F + 22)
End Function


Private Function iData_OpenKalender(FileName As String, Optional ByRef biv As Long, Optional ByRef dbv As Long, Optional updateVer As Boolean) As Boolean
Dim rs As cRecordset
Dim sSQL As String
    With New_c.Connection(FileName, DBOpenFromFile)
        Set mCnn = .CopyDatabase(":memory:")
    End With
    Set rs = mCnn.OpenRecordset("SELECT * FROM einstellungen")
    biv = CURRENT_DB_VER
    dbv = rs!ver
    If updateVer Then
        If Not updateVersion Then Exit Function
    ElseIf dbv <> CURRENT_DB_VER Then
        Exit Function
    End If

    sSQL = "SELECT TOP 1 datum FROM kalender"
    Set rs = mCnn.OpenRecordset(sSQL)
    mJahr = Year(rs.fields(0).Value)
    minD = DateSerial(mJahr, 1, 1)
    maxD = DateSerial(mJahr, 12, 31)

    iData_OpenKalender = True

End Function

Private Function iData_ImportPersonenstamm(FileName As String, Jahr As Integer, Optional bundesland As eBundeslaender) As Boolean
Dim rs As cRecordset
    On Error GoTo ImportPersonenstamm_Error
    With New_c.Connection(FileName, DBOpenFromFile)
        Set rs = .OpenRecordset("SELECT ver FROM einstellungen")
        If rs!ver < CURRENT_DB_VER Then
            Set mCnn = .CopyDatabase(":memory:")
            updateVersion
        ElseIf rs!ver > CURRENT_DB_VER Then
            Err.Raise vbObjectError, "ImportPersonenstamm", "Ungltige Quelldatei!"
        Else
            Set mCnn = .CopyDatabase(":memory:")
        End If
    End With
    iData_NewKalender Jahr, bundesland
    iData_ImportPersonenstamm = True
Exit Function

ImportPersonenstamm_Error:
    Err.Raise Err.Number, "cmUrlaubsplaner.ImportPersonenstamm." & Erl, "Ungltige Quelldatei!"
End Function

Private Function iData_DataChanged() As Boolean
    iData_DataChanged = (mCnn.TotalAffectedRowsInSession > 0)
End Function

Private Function iData_SaveKalender(FileName As String) As Boolean
    With New_c.fso
        If .FileExists(FileName & "~") Then .DeleteFile FileName & "~"
        mCnn.CopyDatabase FileName & "~", , True
        If .FileExists(FileName & "~") Then
            .MoveFile FileName & "~", FileName, True
            With New_c.Connection(FileName, DBOpenFromFile)
                Set mCnn = .CopyDatabase(":memory:")
            End With
        End If
    End With
            
    iData_SaveKalender = True
End Function

Private Function updateVersion() As Boolean
Dim rs As cRecordset
ReDim sSQL(0) As String
Dim r As Integer
Dim isTrans As Boolean

    Set rs = mCnn.OpenSchema
    Do Until rs.EOF
        If rs!Type = "table" Then
            sSQL(0) = rs!SQL
            Select Case rs!name
                Case "personen"
                    If InStr(20, sSQL(0), "kinder", vbTextCompare) = 0 Then
                        r = r + 1: ReDim Preserve sSQL(r)
                        sSQL(r) = "ALTER TABLE personen ADD COLUMN kinder BOOLEAN NOT NULL DEFAULT FALSE"
                    End If
            End Select
        End If
        rs.MoveNext
    Loop
    Set rs = Nothing
    mCnn.BeginTrans
    isTrans = True
    For r = 1 To UBound(sSQL)
        mCnn.Execute sSQL(r)
    Next
    mCnn.Execute "UPDATE einstellungen SET ver=" & CURRENT_DB_VER
    mCnn.CommitTrans
    updateVersion = True
    Exit Function
        
ERR_UPDATE_VERSION:
    On Error GoTo -1
    On Error Resume Next
    If isTrans Then mCnn.RollbackTrans
    MsgBox Err.Description, vbCritical, "Fehler..."
        
End Function


'===Urlaub===
Private Function iData_GetTag(id_kalender As Long) As cRecordset
Dim sSQL As String
    sSQL = "SELECT kalender.id_kalender,urlaub.id_person,urlaub.slot,urlaub.anteil,personen.kuerzel,personen.farbe FROM kalender " & _
        "LEFT JOIN urlaub ON kalender.id_kalender = urlaub.id_kalender " & _
        "LEFT JOIN personen ON urlaub.id_person = personen.id_person " & _
        "WHERE kalender.id_kalender=? ORDER BY urlaub.slot"
    Set iData_GetTag = mCnn.GetRs(sSQL, id_kalender)
End Function

Private Function iData_GetUrlaub() As cRecordset
Dim sSQL As String
    sSQL = "SELECT kalender.id_kalender,urlaub.id_person,urlaub.slot,urlaub.anteil,personen.kuerzel,personen.name,personen.farbe " & _
        "FROM kalender " & _
        "INNER JOIN urlaub ON kalender.id_kalender = urlaub.id_kalender " & _
        "INNER JOIN personen ON urlaub.id_person = personen.id_person " & _
        "ORDER BY kalender.id_kalender,urlaub.slot"
    Set iData_GetUrlaub = mCnn.OpenRecordset(sSQL)
End Function

Private Function iData_GetUrlaubskalender() As cRecordset

    With New_c.StringBuilder
        .AddNL "SELECT "
        .AddNL "kalender.id_kalender,"
        .AddNL "kalender.datum,"
        .AddNL "CAST(strftime('%d',kalender.datum) AS INTEGER) AS tag,"
        .AddNL "CAST(strftime('%m',kalender.datum) AS INTEGER) AS monat,"
        .AddNL "CASE strftime('%w',kalender.datum)"
        .AddNL "WHEN '0' THEN 'So'"
        .AddNL "WHEN '1' THEN 'Mo'"
        .AddNL "WHEN '2' THEN 'Di'"
        .AddNL "WHEN '3' THEN 'Mi'"
        .AddNL "WHEN '4' THEN 'Do'"
        .AddNL "WHEN '5' THEN 'Fr'"
        .AddNL "WHEN '6' THEN 'Sa'"
        .AddNL "END AS wtag,"
        .AddNL "CASE strftime('%w',kalender.datum)"
        .AddNL "WHEN '0' THEN 1"
        .AddNL "WHEN '6' THEN 1"
        .AddNL "ELSE 0"
        .AddNL "END AS we,"
        .AddNL "feiertage.name AS feiertag,"
        .AddNL "ferien.id_ferien,"
        .AddNL "betriebsurlaub.name AS burlaub,"
        .AddNL "urlaub.slot,"
        .AddNL "urlaub.anteil,"
        .AddNL "urlaub.id_person,"
        .AddNL "personen.kuerzel,"
        .AddNL "personen.name,"
        .AddNL "personen.farbe"
        .AddNL "FROM kalender"
        .AddNL "LEFT JOIN feiertage ON kalender.id_kalender = feiertage.id_feiertag"
        .AddNL "LEFT JOIN ferien ON kalender.id_ferien = ferien.id_ferien"
        .AddNL "LEFT JOIN betriebsurlaub ON (kalender.id_burlaub = betriebsurlaub.id_burlaub)"
        .AddNL "LEFT JOIN urlaub ON kalender.id_kalender = urlaub.id_kalender"
        .AddNL "LEFT JOIN personen ON urlaub.id_person = personen.id_person"
        .AddNL "ORDER BY kalender.id_kalender,urlaub.slot"
        Set iData_GetUrlaubskalender = mCnn.OpenRecordset(.ToString)
    End With
    

End Function


Private Function iData_ToggleUrlaub(id_kalender As Long, id_person As Long, slot As Integer, ByRef verplant As Single, ByRef ueberzogen As Boolean) As Boolean
Dim sSQL As String
Dim rs As cRecordset
Dim isTrans As Boolean
Dim kontingent As Single
    On Error GoTo Err_ToogleUrlaub
    sSQL = "SELECT personen.kontingent, COALESCE(sum(anteil),0) + (" & _
           "SELECT COALESCE(SUM(betriebsurlaub.anteil),0) FROM betriebsurlaub INNER JOIN kalender ON betriebsurlaub.id_burlaub = kalender.id_burlaub) AS verplant FROM personen " & _
           "LEFT JOIN urlaub ON personen.id_person = urlaub.id_person " & _
           "WHERE personen.id_person=" & id_person & " GROUP BY personen.kontingent"
    Set rs = mCnn.OpenRecordset(sSQL)
    If Not rs.EOF Then
        verplant = rs!verplant
        kontingent = rs!kontingent
    End If
    sSQL = "SELECT id_kalender,id_person,slot,anteil FROM urlaub WHERE id_kalender=" & id_kalender  'Tag abrufen
    Set rs = mCnn.OpenRecordset(sSQL)
    If rs.EOF Then 'An diesem Tag sind noch keine Urlaube verplant, Urlaubstag hinzufgen
        rs.AddNew
            rs!id_kalender = id_kalender
            rs!id_person = id_person
            rs!slot = slot
        rs.UpdateBatch
        verplant = verplant + 1
        Debug.Print "AddNew to " & id_kalender & " Person:" & id_person & " Slot:" & slot
    Else
        If rs.FindFirst("id_person=" & id_person) Then
            Select Case True
                Case rs!slot <> slot    'Slot ndern
                    Debug.Print "ChanceSlot on " & id_kalender & " Person:" & id_person & " Slot:" & rs!slot & "->" & slot
                    If rs!slot = 0 Then
                        rs!slot = slot
                        rs.UpdateBatch
                    Else
                        mCnn.BeginTrans
                        isTrans = True
                        mCnn.Execute "UPDATE urlaub SET id_kalender=0,slot=" & rs!slot & " WHERE id_kalender=" & id_kalender & " AND slot=" & slot
                        mCnn.Execute "UPDATE urlaub SET slot=" & slot & " WHERE id_kalender=" & id_kalender & " AND slot=" & rs!slot
                        mCnn.Execute "UPDATE urlaub SET id_kalender=" & id_kalender & " WHERE id_kalender=0"
                        mCnn.CommitTrans
                    End If
                Case rs!slot = slot 'Urlaubstag lschen
                    rs.Delete
                    rs.UpdateBatch
                    verplant = verplant - 1
                    Debug.Print "Delete on " & id_kalender & " Person:" & id_person & " Slot:" & slot
                Case Else: Exit Function
            End Select
        Else
            rs.AddNew: rs!id_kalender = id_kalender: rs!id_person = id_person: rs!slot = slot: rs.UpdateBatch
            verplant = verplant + 1
            Debug.Print "AddNew to " & id_kalender & " Person:" & id_person & " Slot:" & slot
        End If
    End If
    ueberzogen = verplant > kontingent
    iData_ToggleUrlaub = True
    Exit Function
    
    
Err_ToogleUrlaub:
    If isTrans Then
        On Error GoTo -1
        On Error Resume Next
        mCnn.RollbackTrans
    End If
End Function



Private Function iData_Defrag() As Integer
Dim t As Integer, s As Integer
Dim rs As RC6.cRecordset
Dim kalender() As Long
Dim slots As Integer, Tage As Integer

    On Error GoTo ERR_DEFRAG
    Set rs = mCnn.OpenRecordset("SELECT max(slot) from urlaub")
    slots = rs.fields(0).Value
    If slots = 0 Then Exit Function
    Set rs = mCnn.OpenRecordset("SELECT distinct id_kalender FROM urlaub")
    Tage = rs.RecordCount
    If Tage < 1 Then Exit Function
    Set rs = mCnn.OpenRecordset("SELECT urlaub.id_kalender,urlaub.id_person,urlaub.slot FROM urlaub " & _
                                "INNER JOIN personen ON urlaub.id_person=personen.id_person ORDER BY id_kalender,personen.name")
    ReDim kalender(Tage - 1, slots)
    'Daten einlesen und neu anordnen
    Do Until rs.EOF
        If kalender(t, 0) <> rs!id_kalender Then
            If kalender(0, 0) > 0 Then t = t + 1
            kalender(t, 0) = rs!id_kalender
        End If
        For s = 1 To slots
            If kalender(t, s) = 0 Then
                kalender(t, s) = rs!id_person
                Exit For
            End If
        Next
        rs.MoveNext
    Loop
    Set rs = Nothing
    'Daten defragmentieren
    
    'Daten bernehmen
    mCnn.BeginTrans
    mCnn.Execute "UPDATE urlaub SET slot=slot+100"
    For t = 0 To UBound(kalender, 1)
        For s = 1 To UBound(kalender, 2)
            If kalender(t, s) > 0 Then
                mCnn.Execute "UPDATE urlaub SET slot=" & s & " WHERE id_kalender=" & kalender(t, 0) & " AND id_person=" & kalender(t, s)
            Else
                Exit For
            End If
        Next
    Next
    mCnn.CommitTrans
    Set rs = mCnn.OpenRecordset("SELECT max(slot) from urlaub")
    iData_Defrag = rs.fields(0).Value
    Exit Function
    
ERR_DEFRAG:
    'errors.Add Err.Description
    On Error GoTo -1
    On Error Resume Next
    mCnn.RollbackTrans
    'errors.Add HtmlHelper.Escape(Err.Description)
End Function

