VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cvOptionen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements iDocument

Private mWV As cWebView2
Private mSB As RC6.cStringBuilder

Private Sub Class_Initialize()
    Set mSB = New_c.StringBuilder
End Sub

Private Sub iDocument_LoadPage(WvBrowser As RC6.cWebView2, Settings As RC6.cRecordset, Optional Skin As SkinConstants)
Dim template As String
Dim cssSkin As String
Dim resSvg
Dim i As Integer
    Set mWV = WvBrowser
    If HtmlHelper.ReadFromRes Then
        mWV.Navigate "file:///" & Replace(AppPath, "\", "/") & "/Res/optionen.html"
    Else
        template = HtmlHelper.Crypt.UTF8ToVBString(HtmlHelper.AppRes.GetContent("optionen.html"))
        resSvg = Array("help.svg", "import.svg")
        For i = 0 To UBound(resSvg)
            template = Replace$(template, resSvg(i), HtmlHelper.LoadResSvg(CStr(resSvg(i))), , 1)
        Next i
        If Skin = skDark Then
            cssSkin = HtmlHelper.Crypt.UTF8ToVBString(HtmlHelper.AppRes.GetContent("dark.css"))
            template = Replace(template, "<!--skin-->", "<style> " & cssSkin & " </style>", , 1)
        End If
        mWV.NavigateToString template
    End If
End Sub



Public Sub ShowSettings(FileSettings As cRecordset, ProgrammSettings As cHashD)
'    With mWV
'        .jsProp("document.getElementById('txtSlots').value") = rs!slots
'        .jsProp("document.getElementById('colFeiertage').value") = rs!cfeiertag
'        .jsProp("document.getElementById('colFerien').value") = rs!cFerien
'        .jsProp("document.getElementById('colBetriebsurlaub').value") = rs!cUrlaub
'    End With
    With mSB
        .Clear
        .Add "(function() {"
        .Add "document.getElementById('usedSlots').innerHTML='" & FileSettings!minSlots & "';"
        .Add "document.getElementById('txtSlots').value=" & FileSettings!slots & ";"
        .Add "document.getElementById('txtSlots').min=" & FileSettings!minSlots & ";"
        .Add "document.getElementById('colFeiertage').value='" & FileSettings!cfeiertag & "';"
        .Add "document.getElementById('colFerien').value='" & FileSettings!cFerien & "';"
        .Add "document.getElementById('colBetriebsurlaub').value='" & FileSettings!cUrlaub & "';"
        .Add "document.getElementById('txtCSV').value='" & ProgrammSettings("CsvTemplate") & "';"
        .Add "document.getElementById('selPDF').value='" & ProgrammSettings("PdfFormat") & "';"
        .Add "document.getElementById('selSkin').value='" & ProgrammSettings("Skin") & "';"
        .Add "document.getElementById('chkOpen').checked=" & IIf(ProgrammSettings("OpenFile"), "true", "false") & ";"
        .Add "})();"
        mWV.ExecuteScript .ToString
    End With
End Sub

Public Sub ShowFeiertage(rs As cRecordset, jahr As Long)
Dim minD As String, maxD As String

    minD = jahr & "-01-01"
    maxD = jahr & "-12-31"
        
    With mSB
        .Clear
        .Add "<table id='tblFeiertage'>"
        .Add "<colgroup><col style='width:150px'><col style='width:120px'><col width='60' style='width:60px'></colgroup>"
        .Add "<thead><tr><th>Feiertag</th><th>Datum</th><th>Lschen</th></tr></thead><tbody>"
        Do Until rs.EOF
            .Add "<tr>"
            .Add "<td><input id='txtFtN" & rs!id_feiertag & "' type='text' value='" & rs!name & "' maxlength=30 class='feiertag' style='width:95%' /></td>"
            .Add "<td><input id='txtFtD" & rs!id_feiertag & "' type='date' value='" & Format$(rs!datum, "yyyy-mm-dd") & "' min='" & minD & "' max='" & maxD & "' style='width:95%' /></td>"
            .Add "<td><span class='del' onclick='delFeiertag(this)'>&#10006;</span></td></tr>"
            rs.MoveNext
        Loop
        .Add "</tbody></table>"
        .Add "<p>&#9998;<a href='javascript:addFeiertag(" & jahr & ")'>Feiertag hinzufgen</a>"
        .Add "<a href='#' id='ipFeiertage' class='import'>Import</a></p>"
        mWV.jsRun "chgElement", "feiertage", .ToString
    End With
            
End Sub

Public Sub ShowFerien(rs As cRecordset, jahr As Long)
Dim minD As String, maxD As String

    minD = jahr & "-01-01"
    maxD = jahr & "-12-31"
    
    With mSB
        .Clear
        .Add "<table id='tblFerien'>"
        .Add "<colgroup><col style='width:150px'><col style='width:120px'><col style='width:60px'></colgroup>"
        .Add "<thead><tr><th>Ferien</th><th>Von</th><th>Bis</th><th>Lschen</th></tr></thead><tbody>"
        Do Until rs.EOF
            .Add "<tr>"
            .Add "<td><input id='txtFeN" & rs!id_ferien & "' type='text' value='" & rs!name & "' maxlength=30 class='ferien' style='width:95%' /></td>"
            If rs!id_ferien > 0 Then
                .Add "<td><input id='txtFvD" & rs!id_ferien & "' type='date' value='" & Format$(rs!ferienstart, "yyyy-mm-dd") & "' min='" & minD & "' max='" & maxD & "' style='width:95%' /></td>"
                .Add "<td><input id='txtFbD" & rs!id_ferien & "' type='date' value='" & Format$(rs!ferienende, "yyyy-mm-dd") & "' min='" & minD & "' max='" & maxD & "' style='width:95%' /></td>"
            Else
                .Add "<td><input id='txtFvD" & rs!id_ferien & "' type='date' value='' min='" & minD & "' max='" & maxD & "' style='width:95%' /></td>"
                .Add "<td><input id='txtFbD" & rs!id_ferien & "' type='date' value='' min='" & minD & "' max='" & maxD & "' style='width:95%' /></td>"
            End If
            .Add "<td><span class='del' onclick='delFerien(this)'>&#10006;</span></td></tr>"
            rs.MoveNext
        Loop
        .Add "</tbody></table>"
        .Add "<p>&#9998;<a href='javascript:addFerien(" & jahr & ")'>Ferien hinzufgen</a>"
        .Add "<a href='#' id='ipFerien' class='import'>Import</a></p>"
        mWV.jsRun "chgElement", "ferien", .ToString
    End With
End Sub

Public Sub ShowBetriebsurlaub(rs As cRecordset, jahr As Long)
Dim minD As String, maxD As String

    minD = jahr & "-01-01"
    maxD = jahr & "-12-31"
    
    With mSB
        .Clear
        .Add "<table id='tblUrlaub'>"
        .Add "<colgroup><col style='width:150px'><col style='width:120px'><col style='width:60px'></colgroup>"
        .Add "<thead><tr><th>Betriebsurlaub</th><th>Von</th><th>Bis</th><th>Lschen</th></tr></thead><tbody>"
        Do Until rs.EOF
            .Add "<tr>"
            .Add "<td><input id='txtBuN" & rs!id_burlaub & "' type='text' value='" & rs!name & "' maxlength=30 class='urlaub' style='width:95%' /></td>"
            .Add "<td><input id='txtBvD" & rs!id_burlaub & "' type='date' value='" & Format$(rs!bustart, "yyyy-mm-dd") & "' min='" & minD & "' max='" & maxD & "' style='width:95%' /></td>"
            .Add "<td><input id='txtBbD" & rs!id_burlaub & "' type='date' value='" & Format$(rs!buende, "yyyy-mm-dd") & "' min='" & minD & "' max='" & maxD & "' style='width:95%' /></td>"
            .Add "<td><span class='del' onclick='delUrlaub(this)'>&#10006;</span></td></tr>"
            rs.MoveNext
        Loop
        .Add "</tbody></table>"
        .Add "<p>&#9998;<a href='javascript:addUrlaub(" & jahr & ")'>Betriebsurlaub hinzufgen</a>"
        .Add "<a href='#' id='ipUrlaub' class='import'>Import</a></p>"
        mWV.jsRun "chgElement", "betriebsurlaub", .ToString
    End With
End Sub

