VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cvUrlaubsplaner"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements iDocument

Private mWV As cWebView2
Attribute mWV.VB_VarHelpID = -1
Private mSB As RC6.cStringBuilder
Private mCurrentPersonId As Long
Private mPersonenCollapsed As Boolean
Private mColorFeiertag As String
Private mColorFerien As String
Private mColorUrlaub As String
Private mSlots As Integer


Private Sub Class_Initialize()
    Set mSB = New_c.StringBuilder
    mColorFeiertag = "#CCBBCC"
    mColorFerien = "#FFFF99"
    mColorUrlaub = "#CCFFDD"
End Sub


Public Property Get PersonenCollapsed() As Boolean
    PersonenCollapsed = mPersonenCollapsed
End Property

Public Property Let PersonenCollapsed(ByVal vNewValue As Boolean)
    mPersonenCollapsed = vNewValue
End Property


Public Property Get CurrentPersonId() As Long
    CurrentPersonId = mCurrentPersonId
End Property

Public Property Let CurrentPersonId(ByVal vNewValue As Long)
    mCurrentPersonId = vNewValue
End Property



Private Sub iDocument_LoadPage(WvBrowser As RC6.cWebView2, Settings As RC6.cRecordset, Optional Skin As SkinConstants)
Dim template As String
Dim cssSkin As String
Dim resSvg
Dim i As Integer
    mCurrentPersonId = 0
    mPersonenCollapsed = False
    If Not Settings Is Nothing Then
        mSlots = Settings!slots
        mColorFeiertag = Settings!cfeiertag
        mColorFerien = Settings!cFerien
        mColorUrlaub = Settings!cUrlaub
    End If
    Set mWV = WvBrowser
    If HtmlHelper.ReadFromRes Then
        mWV.Navigate "file:///" & Replace(AppPath, "\", "/") & "/Res/urlaubsplaner.html"
    Else
        template = HtmlHelper.Crypt.UTF8ToVBString(HtmlHelper.AppRes.GetContent("urlaubsplaner.html"))
        resSvg = Array("close.svg", "defrag.svg", "new.svg", "open.svg", "opt.svg", "print.svg", "save.svg")
        For i = 0 To UBound(resSvg)
            template = Replace$(template, resSvg(i), HtmlHelper.LoadResSvg(CStr(resSvg(i))), , 1)
        Next i
        If Skin = skDark Then
            cssSkin = HtmlHelper.Crypt.UTF8ToVBString(HtmlHelper.AppRes.GetContent("dark.css"))
            template = Replace$(template, "<!--skin-->", "<style> " & cssSkin & " </style>", , 1)
        End If
        mWV.NavigateToString template
        mWV.jsProp("document.title") = "Urlaubsplaner " & Settings!jahr
    End If

End Sub


Public Sub ShowKalender(rs As RC6.cRecordset)
Dim i As Integer, s As Integer
Dim isFerien As Boolean, isWochenende As Boolean, isBetriebsurlaub As Boolean, isFeiertag As Boolean
Dim bc As String
    With mSB
        .Clear
        .Add "<h1>" & mWV.DocumentTitle & "</h1>"
        .Add "<table width=100%>"
        .Add "<tr>"
        For i = 1 To 12
            .Add "<th colspan=" & (mSlots + 2) & " width=8%>" & MonthName(i) & "</th>"
        Next
        Do Until rs.EOF
            For i = 1 To 12
                isFerien = False: isWochenende = False: isBetriebsurlaub = False: isFeiertag = False
                If i = 1 Then .Add "<tr>"
                If Not rs.EOF Then
                    If rs!monat = i Then
                        bc = ""
                        If Not IsEmpty(rs!feiertag) Then    'Feiertag
                            isFeiertag = True
                            bc = " style='background-color:" & mColorFeiertag & ";color:" & HtmlHelper.CompColor(mColorFeiertag) & "'"
                            .Add "<td class='r'" & bc & ">" & rs!tag & "</td>"
                            .Add "<td" & bc & ">" & rs!wtag & "</td>"
                            .Add "<td" & bc & " class='fday' colspan=" & mSlots & ">" & rs!feiertag & "</td>"
                        ElseIf Not IsEmpty(rs!burlaub) Then    'Betriebsurlaub
                            isBetriebsurlaub = True
                             bc = " style='background-color:" & mColorUrlaub & ";color:" & HtmlHelper.CompColor(mColorUrlaub) & "'"
                            .Add "<td class='r'" & bc & ">" & rs!tag & "</td>"
                            .Add "<td" & bc & ">" & rs!wtag & "</td>"
                            .Add "<td" & bc & " class='fday' colspan=" & mSlots & ">" & rs!burlaub & "</td>"
                        Else
                            If Not IsEmpty(rs!id_ferien) Then
                                bc = " style='background-color:" & mColorFerien & ";color:" & HtmlHelper.CompColor(mColorFerien) & "'"  'Ferien
                                isFerien = True
                            End If
                            If rs!we Then
                                bc = " style='background-color:#CCC'" 'Wochenende, Ferien-bc wird ggf. berschrieben
                                isWochenende = True
                            End If
                            .Add "<td class='r'" & bc & ">" & rs!tag & "</td>"
                            .Add "<td" & bc & ">" & rs!wtag & "</td>"
                            For s = 1 To mSlots
                                If isFeiertag Or isWochenende Or isBetriebsurlaub Then
                                    .Add "<td" & bc & ">" & "</td>"
                                Else
                                    .Add "<td" & bc & " class='sday' id='" & rs!id_kalender & "_" & s & "'>" & "</td>"
                                End If
                            Next
                        End If
                        rs.MoveNext
                    Else
                        .Add "<td colspan=" & (mSlots + 2) & "></td>"
                    End If
                Else
                    .Add "<td colspan=" & (mSlots + 2) & "></td>"
                End If
                If i = 12 Then .Add "</tr>"
            Next i
        Loop
        .Add "</table>"
        mWV.jsRun "chgElement", "kalender", .ToString
    End With
                
End Sub


Public Sub ShowPersonen(rs As cRecordset)

    If Not rs.EOF Then
        If mCurrentPersonId = 0 Then mCurrentPersonId = rs!id_person
    End If

    If mPersonenCollapsed Then
        ShowPersonenCollapsed rs
        mWV.jsRun "chgElement", "personen", mSB.ToString
    Else
        ShowPersonenExpanded rs
        mWV.jsRun "chgElement", "personen", mSB.ToString
        mWV.ExecuteScript "document.getElementById('txtKz0').focus()"
    End If

End Sub

Private Sub ShowPersonenCollapsed(rs As cRecordset)
Dim kontingent As Single, verplant As Single, farbe As String

    With mSB
        .Clear
        .Add "<div style='margin:5px 5px 10px'><div style='float:left;font-size:larger;'>Person: "
        .Add "<select name='person' id='selPerson'>"
        Do Until rs.EOF
            .Add "<option "
                 If mCurrentPersonId = rs!id_person Then
                    .Add "selected "
                    kontingent = rs!kontingent
                    verplant = rs!verplant
                    farbe = rs!farbe
                 End If
                .Add "value='" & rs!id_person & "'>" & rs!kuerzel & " - " & rs!name & "</option>"
            rs.MoveNext
        Loop
        .Add "</select></div>"
        .Add "<div style='float:left;margin-left:10px;margin-right:10px;padding:2px 5px;font-weight:normal'>"
            .Add "<span id='farbe' style='border:1px solid grey;padding:0 5px;background-color:" & farbe & "'>&nbsp</span> "
            .Add "Kontingent: <span id='kontingent'> " & kontingent & "</span> "
            .Add "Verplant: <span " & IIf(verplant > kontingent, "class='overdraw' ", " ") & "id='verplant" & mCurrentPersonId & "'> " & verplant & "</span></div>"
        .Add "<div style='float:clear;margin:2px'><button id='btnCollapse' style='font-size:xx-small' class='btn'>&#9660;</button></div></div>"
    End With

End Sub

Public Sub ShowPersonenExpanded(rs As cRecordset)
Dim id As Long, row As Integer, col As Integer
Dim kontingent As Single, verplant As Single, farbe As String
Dim pCount As Integer
Dim newColor As String
Const T_HEAD As String = "<tr><th></th><th>Farbe</th><th title='Namens-Krzel'>KZ</th><th>Name</th><th title='Schulpdlichtige Kinder'>SK</th><th>Anspruch</th><th>Verplant</th>"
    pCount = rs.RecordCount
    Randomize
    newColor = "#" & Hex$(Int((11 * Rnd) + 4)) & Hex$(Int(15 * Rnd)) & Hex$(Int((11 * Rnd) + 4)) & Hex$(Int(15 * Rnd)) & Hex$(Int((11 * Rnd) + 4)) & Hex$(Int(15 * Rnd))
    
    With mSB
        .Clear
        .Add "<div style='float:left'>"
        .Add "<table class='personen'><thead>"
        .Add "<tr><th colspan=7><div style='float:left;font-size:larger;color:white'>Personen</div>"
        If mCurrentPersonId > 0 And pCount < 3 Then .Add "<div style='float:right'><button id='btnCollapse' style='font-size:xx-small' class='btn'>&#9650;</button></div>"
        .Add "</th></tr>"
        .Add T_HEAD
        .Add "</thead><tbody>"
        Do Until rs.EOF
            row = row + 1
            kontingent = rs!kontingent
            verplant = rs!verplant
            farbe = rs!farbe
            If pCount > 3 Then
                If row > ((pCount \ 2) + 1) And col = 0 Then
                    col = 1
                    .Add "</tfoot></table></div>"
                    .Add "<div><table class='personen' style='margin-left:40px'><thead>"
                    .Add "<tr><th colspan=7><div style='float:right'><button id='btnCollapse' style='font-size:xx-small' class='btn'>&#9650;</button></div></th></tr>"
                    .Add T_HEAD
                    .Add "</thead><tbody>"
                End If
            End If
            id = rs!id_person
            .Add "<tr>"
            .Add "<td class='c'><input type='radio' id='radSel" & id & "' name='sel' value='" & id & "'"
                If id = mCurrentPersonId Then .Add " checked></td>" Else .Add "></td>"
            .Add "<td><input type='color' id='col" & id & "' value='" & farbe & "'></td>"
            .Add "<td><input class='txt' id='txtKz" & id & "' type='text' maxlength=2 value='" & rs!kuerzel & "' style='width:25px' /></td>"
            .Add "<td><input class='txt' id='txtName" & id & "' type='text' maxlength=30 value='" & rs!name & "' style='width:250px' /></td>"
            .Add "<td class='c'><input type='checkbox' id='chkSk" & id & "' " & IIf(rs!kinder, "checked", "") & "></td>"
            .Add "<td class='r'><input class='txt r' id='txtKontingent" & id & "' type='number' max=99 min=0 step=1 value=" & kontingent & " style='width:40px' /></td>"
            .Add "<td class='r " & IIf(verplant > kontingent, "overdraw", "") & "' id='verplant" & id & "' style='padding-right:10px'>" & (verplant) & "</td></tr>"
            rs.MoveNext
        Loop
        .Add "<tr>"
        .Add "<td>&nbsp;</td>"
        .Add "<td><input type='color' id='col0' value='" & newColor & "'></td>"
        .Add "<td><input class='txt' id='txtKz0' type=text maxlength=2 value='' placeholder='KZ' style='width:25px' /></td>"
        .Add "<td><input class='txt' id='txtName0' type=text maxlength=30 value='' placeholder='Name, Vorname' style='width:250px' /></td>"
        .Add "<td class='c'><input type='checkbox' id='chkSk0'></td>"
        .Add "<td class='r'><input class='txt r' id='txtKontingent0' type='number' max=99 min=0 maxlength=2 step=1 value=0 style='width:40px' /></td>"
        .Add "<td class='r' style='padding-right:10px'>0</td></tr>"
        .Add "</tbody><tfoot><tr>"
        .Add "<td align=right colspan=7><button id='btnSave' class='btn' accesskey=''><span></span>bernehmen</button>"
            If mCurrentPersonId > 0 Then .Add " <button id='btnDelete' class='btn' accesskey='l'><span>L</span>schen</button>"
        .Add "</td></tr>"
        .Add "</tfoot></table></div>"
        If pCount < 1 Then
            .Add "<div id='info'>"
            .Add mWV.jsProp("document.getElementById('infoPersonen').innerHTML")
            .Add "</div>"
        End If
    End With

End Sub



Public Sub RefreshTag(rs As cRecordset, id_kalender As Long)
Dim s As Integer
Dim id As String
    With mSB
        .Clear
        .Add "(function() {let t;"
        .Add "let b=document.defaultView.getComputedStyle(document.body,null).backgroundColor;"
        .Add "let f=document.defaultView.getComputedStyle(document.body,null).color;"
        For s = 1 To mSlots
            id = id_kalender & "_" & s
            .Add "t=document.getElementById('" & id & "');"
            .Add "t.innerHTML='';"
            .Add "t.style.backgroundColor = b;"
            .Add "t.style.color = f;"
        Next s
        Do Until rs.EOF
            id = id_kalender & "_" & rs!slot
            .Add "t=document.getElementById('" & id & "');"
            .Add "t.innerHTML='" & rs!kuerzel & "';"
            .Add "t.style.backgroundColor='" & rs!farbe & "';"
            .Add "t.style.color='" & HtmlHelper.CompColor(rs!farbe) & "';"
            rs.MoveNext
        Loop
        .Add "})();"
        mWV.ExecuteScript .ToString
    End With
        
    

End Sub

Public Sub RefreshVerplant(verplant As Single, Optional ueberzogen As Boolean, Optional id_person As Long)
    If id_person = 0 Then id_person = mCurrentPersonId
    With mSB
        .Clear
        .Add "(function() {let e=document.getElementById('verplant" & id_person & "');"
        .Add "e.innerHTML='" & verplant & "';"
        If ueberzogen Then
            .Add "e.classList.add('overdraw');"
        Else
            .Add "e.classList.remove('overdraw');"
        End If
        .Add "})();"
        mWV.ExecuteScript .ToString
    End With

End Sub



Public Sub ShowUrlaub(rs As RC6.cRecordset)
Dim id As String
'mWV.jsRun "test"
'    With mWV
'        .jsRun "clsKalender"
'        Do Until rs.EOF
'            id = rs!id_kalender & "_" & rs!slot
'            .jsRun "chgElement", id, rs.Fields("kuerzel").Value
'            .jsProp("document.getElementById('" & id & "').style.backgroundColor") = rs!farbe
'            .jsProp("document.getElementById('" & id & "').style.color") = HtmlHelper.CompColor(rs!farbe)
'            rs.MoveNext
'        Loop
'   End With
   
    With mSB
        .Clear
        .Add "(function() {let e;"
        .Add "let b=document.defaultView.getComputedStyle(document.body,null).backgroundColor;"
        .Add "let f=document.defaultView.getComputedStyle(document.body,null).color;"
        .Add "let sdays = document.getElementsByClassName('sday');"
        .Add "for(e of sdays){"
        .Add "e.style.color=f;"
        .Add "e.style.backgroundColor=b;"
        .Add "e.innerHTML='';}"
        Do Until rs.EOF
            id = rs!id_kalender & "_" & rs!slot
            .Add "e=document.getElementById('" & id & "');"
            .Add "e.innerHTML='" & rs.fields("kuerzel").Value & "';"
            .Add "e.style.backgroundColor='" & rs!farbe & "';"
            .Add "e.style.color='" & HtmlHelper.CompColor(rs!farbe) & "';"
            rs.MoveNext
        Loop
        .Add "})();"
        mWV.ExecuteScript .ToString
    End With
   
End Sub



